-- phpMyAdmin SQL Dump
-- version 4.5.1
-- http://www.phpmyadmin.net
--
-- Host: 127.0.0.1
-- Generation Time: Dec 22, 2017 at 03:10 PM
-- Server version: 10.1.9-MariaDB
-- PHP Version: 5.6.15

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Database: `easy_lms`
--

-- --------------------------------------------------------

--
-- Table structure for table `lms_books`
--

CREATE TABLE `lms_books` (
  `book_id` int(10) NOT NULL,
  `name` varchar(150) NOT NULL,
  `isbn` varchar(20) NOT NULL,
  `description` text NOT NULL,
  `language` varchar(50) NOT NULL,
  `publisher` varchar(50) NOT NULL,
  `published_year` int(20) NOT NULL,
  `barcode_id` varchar(20) NOT NULL,
  `category` varchar(20) NOT NULL,
  `location` varchar(50) NOT NULL,
  `quantity` int(10) NOT NULL,
  `photo` varchar(150) DEFAULT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `author` varchar(50) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `lms_categories`
--

CREATE TABLE `lms_categories` (
  `id` int(11) NOT NULL,
  `name` varchar(50) NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `lms_class`
--

CREATE TABLE `lms_class` (
  `id` int(10) NOT NULL,
  `class` varchar(50) NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `lms_designation`
--

CREATE TABLE `lms_designation` (
  `id` int(11) NOT NULL,
  `name` varchar(50) NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `lms_ebooks`
--

CREATE TABLE `lms_ebooks` (
  `ebook_id` int(10) NOT NULL,
  `name` varchar(150) NOT NULL,
  `isbn` varchar(20) NOT NULL,
  `description` text NOT NULL,
  `language` varchar(50) NOT NULL,
  `publisher` varchar(50) NOT NULL,
  `published_year` int(20) NOT NULL,
  `category` varchar(20) NOT NULL,
  `photo` varchar(150) DEFAULT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `author` varchar(50) NOT NULL,
  `download_file` varchar(100) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `lms_issue`
--

CREATE TABLE `lms_issue` (
  `id` int(10) NOT NULL,
  `user_id` int(11) NOT NULL,
  `issued_days` int(11) NOT NULL,
  `book_id` int(11) NOT NULL,
  `fine` varchar(11) NOT NULL,
  `status` enum('issue','return','lost') NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `return_date` datetime DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `lms_settings`
--

CREATE TABLE `lms_settings` (
  `id` int(10) NOT NULL,
  `institute_name` varchar(100) DEFAULT NULL,
  `logo` varchar(80) DEFAULT NULL,
  `address` varchar(500) NOT NULL,
  `phone` varchar(12) NOT NULL,
  `email` varchar(100) NOT NULL,
  `min_days` int(2) NOT NULL,
  `max_days` int(11) NOT NULL,
  `fine` int(11) NOT NULL,
  `fine_to_teacher` int(10) NOT NULL,
  `time_zone` varchar(80) NOT NULL,
  `currency` varchar(10) NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `lms_staff`
--

CREATE TABLE `lms_staff` (
  `id` int(10) NOT NULL,
  `user_id` int(10) NOT NULL,
  `member_id` varchar(30) NOT NULL,
  `photo` varchar(50) DEFAULT NULL,
  `designation` varchar(30) NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `lms_students`
--

CREATE TABLE `lms_students` (
  `id` int(10) NOT NULL,
  `user_id` int(10) NOT NULL,
  `photo` varchar(50) DEFAULT NULL,
  `registration_no` varchar(50) NOT NULL,
  `fathers_name` varchar(100) NOT NULL,
  `class` varchar(10) NOT NULL,
  `roll_no` varchar(10) NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Table structure for table `lms_users`
--

CREATE TABLE `lms_users` (
  `user_id` int(11) NOT NULL,
  `name` varchar(80) NOT NULL,
  `email` varchar(120) NOT NULL,
  `username` varchar(120) NOT NULL,
  `password` varchar(180) NOT NULL,
  `phone` int(12) NOT NULL,
  `address` varchar(200) NOT NULL,
  `type` enum('S','T','A') NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


CREATE TABLE `lms_requested` (
  `id` int(11) NOT NULL,
  `user_id` varchar(10) NOT NULL,
  `book_id` varchar(10) NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
--
-- Indexes for dumped tables
--

--
-- Indexes for table `lms_books`
--
ALTER TABLE `lms_books`
  ADD PRIMARY KEY (`book_id`),
  ADD UNIQUE KEY `barcode_id` (`barcode_id`);

--
-- Indexes for table `lms_categories`
--
ALTER TABLE `lms_categories`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `lms_class`
--
ALTER TABLE `lms_class`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `class` (`class`);

--
-- Indexes for table `lms_designation`
--
ALTER TABLE `lms_designation`
  ADD PRIMARY KEY (`id`),
  ADD UNIQUE KEY `name` (`name`);


ALTER TABLE `lms_requested`
  ADD PRIMARY KEY (`id`);
--
-- Indexes for table `lms_ebooks`
--
ALTER TABLE `lms_ebooks`
  ADD PRIMARY KEY (`ebook_id`),
  ADD UNIQUE KEY `isbn` (`isbn`);

--
-- Indexes for table `lms_issue`
--
ALTER TABLE `lms_issue`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `lms_settings`
--
ALTER TABLE `lms_settings`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `lms_staff`
--
ALTER TABLE `lms_staff`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `lms_students`
--
ALTER TABLE `lms_students`
  ADD PRIMARY KEY (`id`);

--
-- Indexes for table `lms_users`
--
ALTER TABLE `lms_users`
  ADD PRIMARY KEY (`user_id`),
  ADD UNIQUE KEY `email` (`email`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `lms_books`
--
ALTER TABLE `lms_books`
  MODIFY `book_id` int(10) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `lms_categories`
--
ALTER TABLE `lms_categories`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;
--
-- AUTO_INCREMENT for table `lms_class`
--
ALTER TABLE `lms_class`
  MODIFY `id` int(10) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `lms_designation`
--
ALTER TABLE `lms_designation`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `lms_ebooks`
--
ALTER TABLE `lms_ebooks`
  MODIFY `ebook_id` int(10) NOT NULL AUTO_INCREMENT;
--
-- AUTO_INCREMENT for table `lms_issue`
--
ALTER TABLE `lms_issue`
  MODIFY `id` int(10) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=14;
--
-- AUTO_INCREMENT for table `lms_settings`
--
ALTER TABLE `lms_settings`
  MODIFY `id` int(10) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=4;
--
-- AUTO_INCREMENT for table `lms_staff`
--
ALTER TABLE `lms_staff`
  MODIFY `id` int(10) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=8;
--
-- AUTO_INCREMENT for table `lms_students`
--
ALTER TABLE `lms_students`
  MODIFY `id` int(10) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=8;
--
-- AUTO_INCREMENT for table `lms_users`
--
ALTER TABLE `lms_users`
  MODIFY `user_id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=28;
--
-- AUTO_INCREMENT for table `lms_requested`
--
ALTER TABLE `lms_requested`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
