<?php

class userdetailsController extends Controller {
	
    private $model;
    private $pagination_limit = 10;
    private $pagination_buttons;
    public $message;

    function __construct()
    { 
        $this->pagination_buttons = array(__('Previous'), __('Next'));
        session::check('user_id', SITE_URL.'login/');
        if(session::get('user_id') == null)
        {
            die();
        }

        $this->data['footer'] = $this->model('settings')->get_settings()[0]->institute_name;
        $this->data['footer_address'] = $this->model('settings')->get_settings()[0]->address;
        $this->data['logo'] = $this->model('settings')->get_settings()[0]->logo;
        $this->data['currency'] = $this->model('settings')->get_currency()->currency;
    }
    
	function actionMain($page = 1) {

        $modal = $this->model('books');
        $issue = $this->model('issue');

        if(isset($_GET['cat']))
            $this->prg('prg_data',SITE_URL.'userdetails/?cat='.$_GET['cat']);
        else
            $this->prg('prg_data',SITE_URL.'userdetails/');

        $filter = array();
        $limit = 'limit 0,'.$this->pagination_limit;
        $this->data['pagination_link'] = '';

        if(isset($_POST['pagination']))
        {
            $page = (int)$_POST['filter'];
        }

        if($page > 1)
        {
            $limit = 'limit '.(($page * $this->pagination_limit) - $this->pagination_limit).','.($this->pagination_limit);
        }

        if(isset($_POST['filter']))
        {

            if(isset($_POST['author_filter']) && $_POST['author_filter'] != '')
            {
                $filter['author'] = $_POST['author_filter'];
            }
            if(isset($_POST['name_filter']) && $_POST['name_filter'] != '')
            {
                $filter['name'] = $_POST['name_filter'];
            }
            if(isset($_POST['isbn_filter']) && $_POST['isbn_filter'] != '')
            {
                $filter['isbn'] = $_POST['isbn_filter'];
            }
            if(isset($_POST['category_filter']) && $_POST['category_filter'] != '')
            {
                $filter['category'] = $_POST['category_filter'];
            }
            $this->data['filter'] = $filter;
        }

        elseif(isset($_GET['cat']))
        {
            $filter['category'] = $_GET['cat'];
            $this->data['filter'] = $filter;
        }

        $this->data['books'] = $modal->get_books_by_id();
        $count = count( $modal->get_books_by_id());

        $this->data['modal'] = $modal;
        $this->error['error_code'] = $modal->flag;
        $this->error['message'] = $modal->message;

        if($page > 1)
        {
            $this->data['pagination_link'] .= '<button type="submit" name="filter" class="previous" value="'.($page - 1).'">Previous</button>';
        }
        if($count > count($this->data['books']) * $page && count($this->data['books']) > 0)
        {
            $this->data['pagination_link'] .= '<button type="submit" name="filter" class="next" value="'.($page + 1).'">Next</button>';
        }


        $this->data['category'] = $modal->get_categories();



        $this->data['page_title'] = __('Home | Library Management System');

        $this->view('header', 'front/templates');
        $this->view('issuedbooks', 'front/templates');
        $this->view('footer', 'front/templates');
	}

    function actionChangePassword() {

        $modal = $this->model('settings');
        if(isset($_POST['submit']))
        {
            $modal->process_password();
            $this->error['error_code'] = $modal->flag;
            $this->error['message'] = $modal->message;
        }


        $this->view('header', 'front/templates');
        $this->view('changepassword', 'front/templates');
        $this->view('footer', 'front/templates');
        
    }

    function actionRequest()
    {
        session::check('user_id', SITE_URL.'login/');

        if (isset($_GET['book_id'])) {
            $model = $this->model('issue');
            $result = $model->process_requested();

            $this->error['error_code'] = $model->flag;
            $this->error['message'] = $model->message;
        }

        
        $this->view('header', 'front/templates');
        $this->view('thankyou', 'front/templates');
        $this->view('footer', 'front/templates');

    }

    function actionCancel($member = false, $book = false)
    {
        if (is_numeric($member) && is_numeric($book) && (!empty($member) && !empty($book))) {

                $_GET['user_id'] = $member;
                $_GET['book_id'] = $book;

            $model = $this->model('issue');
            $result = $model->cancel_requested();

            $this->error['error_code'] = $model->flag;
            $this->error['message'] = $model->message;
        }

        
        $this->view('header', 'front/templates');
        $this->view('thankyou', 'front/templates');
        $this->view('footer', 'front/templates');

    }

    function actionRequested($page = 1) {

        $modal = $this->model('books');
        if(isset($_GET['cat']))
            $this->prg('prg_data',SITE_URL.'userdetails/requested/?cat='.$_GET['cat']);
        else
            $this->prg('prg_data',SITE_URL.'userdetails/requested/');

        $filter = array();
        $limit = 'limit 0,'.$this->pagination_limit;
        $this->data['pagination_link'] = '';

        if(isset($_POST['pagination']))
        {
            $page = (int)$_POST['filter'];
        }
        if($page > 1)
        {
            $limit = 'limit '.(($page * $this->pagination_limit) - $this->pagination_limit).','.($this->pagination_limit);
        }

        if(isset($_POST['filter']))
        {

            if(isset($_POST['author_filter']) && $_POST['author_filter'] != '')
            {
                $filter['author'] = $_POST['author_filter'];
            }
            if(isset($_POST['name_filter']) && $_POST['name_filter'] != '')
            {
                $filter['name'] = $_POST['name_filter'];
            }
            if(isset($_POST['isbn_filter']) && $_POST['isbn_filter'] != '')
            {
                $filter['isbn'] = $_POST['isbn_filter'];
            }
            if(isset($_POST['category_filter']) && $_POST['category_filter'] != '')
            {
                $filter['category'] = $_POST['category_filter'];
            }
            $this->data['filter'] = $filter;
        }

        elseif(isset($_GET['cat']))
        {
            $filter['category'] = $_GET['cat'];
            $this->data['filter'] = $filter;
        }

        $this->data['books'] = $modal->get_requested_books();
        $count = count( $modal->get_requested_books());

        $this->data['modal'] = $modal;
        $this->error['error_code'] = $modal->flag;
        $this->error['message'] = $modal->message;

        if($page > 1)
        {
            $this->data['pagination_link'] .= '<button type="submit" name="filter" class="previous" value="'.($page - 1).'">Previous</button>';
        }
        if($count > count($this->data['books']) * $page && count($this->data['books']) > 0)
        {
            $this->data['pagination_link'] .= '<button type="submit" name="filter" class="next" value="'.($page + 1).'">Next</button>';
        }

        $this->data['category'] = $modal->get_categories();



        $this->data['page_title'] = __('Home | Library Management System');

        $this->view('header', 'front/templates');
        $this->view('requestedbooks', 'front/templates');
        $this->view('footer', 'front/templates');
    }


}


?>