<?php
/**
 * File contains necessary information that defines the bootstrap of your application
 * Source code pattern must not be modified
 * Files to be used with the comments.
 * @Author : Operce Technologies
 * @Developer : Manhar Sharma
 * @Year : 2016
 *
 *
 **/


/**
 * class for login
 * pattern must not be modified
 * Files to be used with the comments.
 *
 *
 */

defined('_DONUT') or die('Error. Invalid Access');

class settings extends Model {
    public $page_title;
    public $message;
    public $flag;
    public $values;
    private $crud;

    function __construct() {
        $this->crud = new crud('lms_settings');
    }

    function process_setting() {
        
        $this->values = $_POST;
        if(!$this->check_form($this->values, ['school_name'=>'Name', 'address' => 'Address', 'email' => 'Email', 'phone' => 'Phone', 'min' => 'Minimum days', 'max' => 'Maximum days', 'fine' => 'Fine', 'fine_teacher' => 'Fine to teacher', 'time_zone' => 'Time zone', 'currency' => 'Currency'] ,'{time_zone},{currency}')) {
            $this->flag = ERROR;
            return false;
        }

        if(!$this->check_data($this->values['email'], 'email')) {
            $this->flag = ERROR;
            $this->message = __('Valid Email is required');
            return false;
        }

        if(!$this->check_data($this->values['phone'], 'int')) {
            $this->flag = ERROR;
            $this->message = __('Valid phone is required');
            return false;
        }

        if($this->processaddfile() == false) {
            return false;
        }
        
        $this->change_setting();
    }

    function get_settings() { 
        $data = $this->crud->get_all();
        return $data;
    }

    private function change_setting() {
        $data_prev = $this->get_settings();
        if(count($data_prev) > 0)
        {
            $args = array();
            if(isset($this->values['school_name']))
                $args['institute_name'] = $this->values['school_name'];

            if(isset($this->values['download_file']))
                $args['logo'] = $this->values['download_file'];

            if(isset($this->values['address']))
                $args['address'] = $this->values['address'];

            if(isset($this->values['phone']))
                $args['phone'] = $this->values['phone'];

            if(isset($this->values['email']))
            {
                $args['email'] = $this->values['email'];
                $pre_email = $this->crud->get_all()[0];

                $my_file = ROOT.DS.'protected/config/config.php';
                $data = file_get_contents($my_file);
                 
                $data = str_replace($pre_email->email,$args['email'],$data);

                $handle = fopen($my_file, 'w') or die('Cannot open file:  '.$my_file);
                fwrite($handle, $data);
                fclose($handle);
            }

            if(isset($this->values['min']))
                $args['min_days'] = $this->values['min'];

            if(isset($this->values['max']))
                $args['max_days'] = $this->values['max'];

            if(isset($this->values['fine']))
                $args['fine'] = $this->values['fine'];

            if(isset($this->values['fine_teacher']))
                $args['fine_to_teacher'] = $this->values['fine_teacher'];

            if(isset($this->values['currency']))
                $args['currency'] = $this->values['currency'];

            if(isset($this->values['time_zone']))
            {
                $args['time_zone'] = $this->values['time_zone'];
                $pre_time = $this->crud->get_all()[0];

                $my_file = ROOT.DS.'protected/config/config.php';
                $data = file_get_contents($my_file);
                 
                $data = str_replace($pre_time->time_zone,$args['time_zone'],$data);

                $handle = fopen($my_file, 'w') or die('Cannot open file:  '.$my_file);
                fwrite($handle, $data);
                fclose($handle);
            }

            $data = $this->crud->update( $args, array( 'id' => $data_prev[0]->id ));
            
            if($data > 0)
            {
                $this->flag = SUCCESS;
                $this->message = __(' settings updated');
                return true;
            }
            else
            {
                $this->flag = WARNING;
                $this->message = __("Setting weren't updated");
                return true;
            }
        }
        else
        {
            $data = $this->crud->insert( array('institute_name' => $this->values['school_name'], 'logo' => $this->values['download_file'], 'address' => $this->values['address'], 'phone' => $this->values['phone'], 'email' => $this->values['email'], 'username' => $this->values['username'], 'password' => $this->values['password'], 'min_days' => $this->values['min'], 'max_days' => $this->values['max'], 'fine' => $this->values['fine'], 'fine_to_teacher' => $this->values['fine_teacher'], 'time_zone' => $this->values['time_zone'], 'currency' => $this->values['currency']) );
            
            if($data > 0)
            {
                $this->flag = SUCCESS;
                $this->message = __(' settings updated');
                return true;
            }
            else
            {
                $this->flag = ERROR;
                $this->message = __("Cannot update settings");
                return true;
            }
        }
        
    }


    function process_password()
    {
     
        $this->values = $_POST;
        if(!$this->check_form($this->values, ['email' => $this->values['email'], 'old'=>'Old Password', 'new' => 'New Password', 'confirm' => 'Confirm Password'])) {
            $this->flag = ERROR;
            return false;
        }

        if($this->values['new'] != $this->values['confirm'])
        {
            $this->flag = ERROR;
            $this->message = __('Passwords donot match');
            return false;
        }

        $this->crud->changeTable('lms_users');

        $this->values['old'] = sha1(AUTH_KEY.$this->values['old']);
        $this->values['new'] = sha1(AUTH_KEY.$this->values['new']);


        $data = $this->crud->update( array('password' => $this->values['new']), array('email' => $this->values['email'], 'password' => $this->values['old'], 'user_id' => session::get('user_id')) );
            
        if($data > 0)
        {
            $this->flag = SUCCESS;
            $this->message = __('Password updated');
            return true;
        }
        else
        {
            $this->flag = ERROR;
            $this->message = __("Wrong password");
            return true;
        }
    }

    function process_username()
    {
     
        $this->values = $_POST;
        if(!$this->check_form($this->values, ['old'=>'Old Username','email'=>'Email', 'new' => 'New Username'])) {
            $this->flag = ERROR;
            return false;
        }

        $this->crud->changeTable('lms_users');


        $data = $this->crud->update( array('username' => $this->values['new']), array('username' => $this->values['old'], 'email' => $this->values['email'], 'user_id' => session::get('user_id')) );
            
        if($data > 0)
        {
            $this->flag = SUCCESS;
            $this->message = __('Username updated');
            return true;
        }
        else
        {
            $this->flag = ERROR;
            $this->message = __("Wrong Username/Email");
            return true;
        }
    }




    function processaddfile()
    {
        $name = $this->name_generator();
        if(isset($_FILES['files']) && $_FILES['files']['name'] != '') {
            $this->values['download_file'] = $_FILES['files'];
            $target_file = basename($this->values["download_file"]["name"]);
            $imageFileType = pathinfo($target_file,PATHINFO_EXTENSION);
            if ($this->values["download_file"]["size"] > 2010000) {
                    $this->flag = ERROR;
                    $this->message = "File is too large";
                    return false;
                }
                // Allow certain file formats
                if($imageFileType != "jpg" && $imageFileType != "png" && $imageFileType != "JPG" && $imageFileType != "PNG" && $imageFileType != "jpeg"
                && $imageFileType != "gif" ) {
                    $this->flag = ERROR;
                    $this->message = "Valid file is required";
                    return false;
                }



            $target_dir = "public/uploads/";
            $temp = explode(".", $this->values["download_file"]["name"]);
            $filenoext = $this->name_generator();
            $newfilename1 = $filenoext . '.' . end($temp);

            if (move_uploaded_file($this->values["download_file"]["tmp_name"], $target_dir.$newfilename1)) {
                $this->values['download_file'] = $target_dir.$newfilename1;
                return true;

            }
            else {
                $this->flag = ERROR;
                $this->message = "Files could not be uploaded";
                return false;
            }
        }
        else
            return true;
    }

    function get_currency()
    {
        $data = $this->get_settings();
        return $data[0];
    }

}