				<div class="row header">
					<div class="col admin-menu">
						<?php include(VIEWS.DS.'menus/_books.php') ?>
					</div>
				</div>
				<div class="row content">
					<div class="row page-heading">
						<h4><?php echo __('Books') ?></h4>
					</div>

					<div class="ajax_response"></div>

					<div class="row filters">
						<form action="#" method="post">							
							<div class="col-6">
								<div class="field-row">
									<label><?php echo __('Category') ?>
									</label>
									<select name="category_filter">
										<option value=""><?php echo __('Select Category') ?></option>
										<?php
										if(isset($category) && count($category) > 0)
										{
											foreach ($category as $key => $value) {
												echo '<option value="'.$value->id.'">'.$value->name.'</option>';
											}
										}
										?>
									</select>
								</div>
							</div>					
							<div class="col-6">
								<div class="field-row">
									<label><?php echo __('Barcode') ?>
									</label>
									<input type="text" name="barcode_filter" placeholder="Ex. 4486" autofocus>
								</div>
							</div>
							<div class="col-6">
								<div class="field-row">
									<label><?php echo __('Author') ?>
									</label>
									<input type="text" name="author_filter" placeholder="Enter author">
								</div>
							</div>

							
							<div class="col-6">
								<div class="field-row">
									<label><?php echo __('Name') ?> 
									</label>
									<input type="text" name="name_filter" placeholder="Enter Name">
									
								</div>
							</div>
							<div class="col-6">
								<div class="field-row">
									<label><?php echo __('ISBN') ?>
									</label>
									<input type="text" name="isbn_filter" placeholder="ISBN">
								</div>
							</div>
							<div class="col-6">
								<input type="submit" name="filter" value="<?php echo __('Filter Results') ?>" class="button2">
							</div>
							</form>
					</div>

					<div class="row helper-menu">				
							<?php $query_str = ''; ?>
							<?php if(isset($filter['category'])) $query_str .= '&category='.$filter['category'] ?>
							<?php if(isset($filter['barcode'])) $query_str .= '&barcode='.$filter['barcode'] ?>
							<?php if(isset($filter['author'])) $query_str .= '&author='.$filter['author'] ?>
							<?php if(isset($filter['name'])) $query_str .= '&name='.$filter['name'] ?>
							<?php if(isset($filter['isbn'])) $query_str .= '&isbn='.$filter['isbn'] ?>				
							<a href="#" class="button2 btn btn-small btn-red btn-round popup-link" data-href="modal_import"><i class="fa fa-file-excel-o" aria-hidden="true"></i> <?php echo __('Import CSV') ?></a>	
							&nbsp;
							<a href="?export<?php echo $query_str ?>" class="button2 btn btn-small btn-orange btn-round"><i class="fa fa-download" aria-hidden="true"></i> <?php echo __('Export data') ?></a>	
					</div>


					<?php
		if(isset($error['error_code']) && isset($error['message'])) {

			if($error['error_code'] == SUCCESS)
				echo '<div class="msg success"><p>'.$error["message"].'</p></div>';
			elseif($error['error_code'] == WARNING)
				echo '<div class="msg warning"><p>'.$error["message"].'</p></div>';
			elseif($error['error_code'] == ERROR)
				echo '<div class="msg fail"><p>'.$error["message"].'</p></div>';

		}

	?>
					<div class="row result-table-wrapper">
						<table class="layout">
							<colgroup>
								<col width="auto">
								<col width="auto">
								<col width="50px">
							</colgroup>
							<thead>
								<tr>
									<td><?php echo __('Book ID') ?></td>
									<td><?php echo __('Book Name') ?></td>
									<td><?php echo __('ISBN') ?></td>
									<td><?php echo __('Description') ?></td>
									<td><?php echo __('Publisher') ?></td>
									<td><?php echo __('Author') ?></td>
									<td><?php echo __('Location') ?></td>
									<td><?php echo __('Quantity') ?></td>
									<td><?php echo __('Issued') ?></td>
									<td></td>
									<td></td>
								</tr>
							</thead>

							<tbody>
								<?php
									if(isset($books))
										foreach ($books as $key => $value) {
											
											$issued_copies = $modal->get_issue_count($value->book_id);

							                if($value->quantity <= 0)
							                {
							                    $tr = '<tr class="highlight-error edit_tr" id="tr_'.$value->book_id.'" data-id="'.$value->book_id.'">';
							                }

							                elseif($modal->get_issue_count($value->book_id,$value->quantity) == false)
							                {
							                	$tr = '<tr class="highlight-warning edit_tr" id="tr_'.$value->book_id.'" data-id="'.$value->book_id.'">';
							                }

							                else 
							                	$tr =  '<tr class="edit_tr" id="tr_'.$value->book_id.'" data-id="'.$value->book_id.'">';

											echo $tr.'<td>'.$value->book_id.'</td>

	<td class="edit_td"><span id="first_'.$value->book_id.'" class="text">'.$value->name.'</span>
	<input type="text" value="'.$value->name.'" class="editbox" id="first_input_'.$value->book_id.'"></td>
											
											<td class="edit_td"><span id="second_'.$value->book_id.'" class="text">'.$value->isbn.'</span>
	<input type="text" value="'.$value->isbn.'" class="editbox" id="second_input_'.$value->book_id.'"></td>

											
											<td class="edit_td"><span id="third_'.$value->book_id.'" class="text">'.get_excerpt($value->description).'</span>
	<textarea class="editbox textarea" id="third_input_'.$value->book_id.'" rows="2" cols="60">'.$value->description.'</textarea></td>

											
											<td class="edit_td"><span id="fourth_'.$value->book_id.'" class="text">'.$value->publisher.'</span>
	<input type="text" value="'.$value->publisher.'" class="editbox" id="fourth_input_'.$value->book_id.'"></td>

											<td class="edit_td"><span id="fifth_'.$value->book_id.'" class="text">'.$value->author.'</span>
	<input type="text" value="'.$value->author.'" class="editbox" id="fifth_input_'.$value->book_id.'"></td>

											<td class="edit_td"><span id="sixth_'.$value->book_id.'" class="text">'.$value->location.'</span>
	<input type="text" value="'.$value->location.'" class="editbox" id="sixth_input_'.$value->book_id.'"></td>

											<td class="edit_td"><span id="seventh_'.$value->book_id.'" class="text">'.$value->quantity.'</span>
	<input type="text" value="'.$value->quantity.'" class="editbox" id="seventh_input_'.$value->book_id.'"></td>
											
											<td>'.$issued_copies.'</td>

											<td><a href="'.SITE_URL.'books/edit?id='.$value->book_id.'"><i class="fa fa-pencil" aria-hidden="true"></i></a></td>
											<td><a href="#" id="'.$value->book_id.'" class="delete_book"><i class="fa fa-trash-o" aria-hidden="true"></i></a></td></tr>';
										}
								?>
							</tbody>
						</table>		
					</div>
					<div class="row pagination">
						<?php
							if(!empty($pagination_link))
							{
								?>
								<form action="#" method="post">
									<input type="hidden" name="pagination">				
									<input type="hidden" name="category_filter" value="<?php if(isset($filter['category'])) echo $filter['category'] ?>">
									<input type="hidden" name="barcode_filter" value="<?php if(isset($filter['barcode'])) echo $filter['barcode'] ?>">
									<input type="hidden" name="author_filter" value="<?php if(isset($filter['author'])) echo $filter['author'] ?>">
									<input type="hidden" name="name_filter" value="<?php if(isset($filter['name'])) echo $filter['name'] ?>">
									<input type="hidden" name="isbn_filter" value="<?php if(isset($filter['isbn'])) echo $filter['isbn'] ?>">
									<?= $pagination_link; ?>
								</form>
								<?php
							}
							?>
					</div>
<script>
						
					jQuery(document).ready(function($)
					{
						$(".edit_tr .delete_book").on('click', function(e)
						{
							e.preventDefault();
						var ID=$(this).attr('id');
						var table_row = $('#tr_'+ID);


						$.ajax({ //ajax form submit
					                url : "<?= SITE_URL ?>books/deletebook",
					                type: "GET",
					                data : 'id='+ID,
					                dataType : "json",
					                contentType: false,
					                cache: false,
					                processData:false
					            }).done(function(res){
					                    $(".ajax_response").html( res.text );
					                    if(res.code == 1)
					                    	table_row.remove();
					            });
					     });


						$(".edit_tr").click(function()
{
var ID=$(this).attr('data-id');
$("#first_"+ID).hide();
$("#first_input_"+ID).show();
$("#second_"+ID).hide();
$("#second_input_"+ID).show();
$("#third_"+ID).hide();
$("#third_input_"+ID).show();
$("#fourth_"+ID).hide();
$("#fourth_input_"+ID).show();
$("#fifth_"+ID).hide();
$("#fifth_input_"+ID).show();
$("#sixth_"+ID).hide();
$("#sixth_input_"+ID).show();
$("#seventh_"+ID).hide();
$("#seventh_input_"+ID).show();
}).change(function()
{
var ID=$(this).attr('data-id');
var first = $("#first_input_"+ID).val();
var second = $("#second_input_"+ID).val();
var third = $("#third_input_"+ID).val();
var fourth = $("#fourth_input_"+ID).val();
var fifth = $("#fifth_input_"+ID).val();
var sixth = $("#sixth_input_"+ID).val();
var seventh = $("#seventh_input_"+ID).val();
var dataString = 'book_name='+first+'&isbn='+second+'&description='+third+'&publisher='+fourth+'&author='+fifth+'&location='+sixth+'&quantity='+seventh+'&id='+ ID;

$.ajax({
type: "POST",
url: "<?= SITE_URL ?>books/updatebook",
data: dataString,
cache: false,
dataType: "json",
success: function(res)
{
	$(".ajax_response").html( res.text );
    var scrollPos =  $(".ajax_response").offset().top;
    $(window).scrollTop(scrollPos);
	$("#first_"+ID).html(first);
	$("#second_"+ID).html(second);
	$("#third_"+ID).html(third);
	$("#fourth_"+ID).html(fourth);
	$("#fifth_"+ID).html(fifth);
	$("#sixth_"+ID).html(sixth);
	$("#seventh_"+ID).html(seventh);
	$("#eight_"+ID).html(eight);
}
});

});

// Edit input box click action
$(".editbox").mouseup(function() 
{
return false
});

// Outside click action
$('body').mouseup(function()
{
$(".editbox").hide();
$(".text").show();
});

					});
					</script>		


				</div>
					
					<div class="popup-container" id="modal_import">
						<div class="popup-window">
							<div class="popup-header"><i class="fa fa-pencil"></i> <?php echo __('Please choose CSV file') ?><a href="#" class="popup-close right" data-href="modal"><i class="fa fa-times" aria-hidden="true"></i></a></div>
							<div class="popup-content">
						
										<form action="#" data-action="<?= SITE_URL ?>/books/import" id="form_import" class="clearfix form form_ajax" method="post">
										
										<div class="row ajax_response"></div>
										<div class="form-body">
											<div class="input-item file-display __text-left"></div>

											<div class="upload-item">
												<label><?php echo __('Books CSV') ?></label>
												<input type="file" id="file_import" name="csv_file" value="" class="file file-upload">
												<label class="title" for="file_import"><i class="fa fa-paperclip" aria-hidden="true"></i> <?php echo __('Select File') ?></label>							
											</div>								

											<button type="submit" class="button send"><?php echo __('Submit') ?></button>
										</div>
									</form>
							</div>
						</div>
					</div>