<?php

class circulationController extends Controller {
    
    private $model;

    function __construct() {
        session::check('user_id', SITE_URL.'login/');
        if(session::get('user_role') != 'A')
        {            
            session::clean_session(SITE_URL.'login/');
            die();
        }

        $this->data['footer'] = $this->model('settings')->get_settings()[0]->institute_name;
        $this->data['footer_address'] = $this->model('settings')->get_settings()[0]->address;
        $this->data['logo'] = $this->model('settings')->get_settings()[0]->logo;
    }
    
    function actionMain()
    {
        $modal = $this->model('books');


        $this->data['page_title'] = __('Circulation | Library Management System');

        $this->data['total_books'] = count($modal->get_books());
        $this->data['total_issued'] = count($this->model('issue')->get_issued());
        $this->data['total_lost'] = count($this->model('issue')->get_lost());
        $this->data['total_returned'] = count($this->model('issue')->get_returned());


        $this->view('header');
        $this->view('dashboard','circulation');
        $this->view('footer');
    }
    function actionIssue($member = false, $book = false, $type = false)
    {
        $modal = $this->model('issue');
        if(!empty($member) && !empty($book) && !empty($type) && ( $book != false && $member != false && $type != false) && ( is_numeric($book) && is_numeric($member)))
        {
            if($type == 'S')
            {
                $_POST['student'] = true;
                $_POST['user_id'] = $member;
                $_POST['book_id'] = $book;
                $_POST['days'] = '';

                $this->data['form_var'] = $_POST;
            }
            else if( $type == 'T')
            {
                 $_POST['member'] = true;
                 $_POST['user_id'] = $member;
                 $_POST['book_id'] = $book;
                 $_POST['days'] = '';

                 $this->data['form_var'] = $_POST;
            }
        }
        if(isset($_POST['member'])) {
            $this->data['teacher'] = true;
        }
        else if(isset($_POST['student'])) {
            $this->data['student'] = true;
        }


        if(isset($_POST['issue']))
        {       

                if(isset($_POST['teacher'])) {
                    $_POST['type'] = 'teacher';
                }
                else if(isset($_POST['student'])) {
                    $_POST['type'] = 'student';
                }


            $modal->process_issue();

            $this->data['form_var'] = $_POST;

            $this->error['message'] = $modal->message;
            $this->error['error_code'] = $modal->flag;

            if($modal->flag != SUCCESS)
            {
                if(isset($_POST['teacher'])) {
                    $this->data['teacher'] = true;
                }
                else if(isset($_POST['student'])) {
                    $this->data['student'] = true;
                }
            }

            
        }


        $this->data['page_title'] = __('Issue Book | Library Management System');


        $this->data['max_days'] = $this->model('settings')->get_settings()[0]->max_days;
        $this->data['min_days'] = $this->model('settings')->get_settings()[0]->min_days;
        
        $this->view('header');
        $this->view('issue','circulation');
        $this->view('footer');
    }
    
    function actionReturn($member = false, $book = false, $type = false)
    {
        if(!empty($member) && !empty($book) && !empty($type) && ( $book != false && $member != false && $type != false) && ( is_numeric($book) && is_numeric($member)))
        {
            if($type == 'S')
            {
                $_POST['type'] = 'student';
                $_POST['user_id'] = $member;

                $this->data['form_var'] = $_POST;
            }
            else if( $type == 'T')
            {
                 $_POST['type'] = 'teacher';
                 $_POST['user_id'] = $member;

                 $this->data['form_var'] = $_POST;
            }
        }
        $modal = $this->model('issue');

        $this->data['page_title'] = __('Return Book | Library Management System');

        $this->view('header');


        if(isset($_POST['type'])) {
            $this->data['type'] = $_POST['type'];
            $this->view('return','circulation');
        }
        else if(isset($_POST['type'])) {
            $this->data['type'] = $_POST['type'];
            $this->view('return','circulation');
        }
        else
            $this->view('return','circulation');


        if(isset($_POST['return']))
        {
            $this->data['currency'] = $this->model('settings')->get_currency()->currency;
            
            $this->data['books'] = $modal->get_books();
            $this->error['message'] = $modal->message;
            $this->error['error_code'] = $modal->flag;
            $this->view('user','circulation');
        }

        $this->view('footer');
    }


    function actionReturnBooks()
    {
        if(Helpers::isAjax())
        {
            $modal = $this->model('issue');

            $modal->process_return_book();

            $response = ($modal->flag == SUCCESS) ? '<div class="msg success"><p>'.$modal->message.'</p></div>' : '<div class="msg fail"><p>'.$modal->message.'</p></div>' ;
            $code = $modal->flag;

            echo json_encode(array('text'=>$response, 'code'=>$code));
        }
    }

    function actionLostBook()
    {
        if(Helpers::isAjax())
        {
            $modal = $this->model('issue');

            $modal->process_lost_book();

            $response = ($modal->flag == SUCCESS) ? '<div class="msg success"><p>'.$modal->message.'</p></div>' : '<div class="msg fail"><p>'.$modal->message.'</p></div>' ;
            $code = $modal->flag;

            echo json_encode(array('text'=>$response, 'code'=>$code));
        }
    }
    
}
?>