<?php

class defaultController extends Controller {
	
    private $model;
    private $pagination_limit = 10;
    private $pagination_buttons;
    public $message;

    function __construct()
    {
        $this->pagination_buttons = array(__('Previous'), __('Next'));
        if(INSTALL == '%install%')
        {
            die('please install the app first.');
        }

        $this->data['footer'] = $this->model('settings')->get_settings()[0]->institute_name;
        $this->data['footer_address'] = $this->model('settings')->get_settings()[0]->address;
        $this->data['logo'] = $this->model('settings')->get_settings()[0]->logo;
    }
    
	function actionMain($page = 1) {

		$modal = $this->model('books');

        if(isset($_GET['cat']))
            $this->prg('prg_data',SITE_URL.'?cat='.$_GET['cat']);
        else
            $this->prg('prg_data',SITE_URL);

        $filter = array();
        $limit = 'limit 0,'.$this->pagination_limit;
        $this->data['pagination_link'] = '';

        if(isset($_POST['pagination']))
        {
            $page = (int)$_POST['filter'];
        }

        if($page > 1)
        {
            $limit = 'limit '.(($page * $this->pagination_limit) - $this->pagination_limit).','.($this->pagination_limit);
        }

        if(isset($_POST['filter']))
        {

            if(isset($_POST['author_filter']) && $_POST['author_filter'] != '')
            {
                $filter['author'] = $_POST['author_filter'];
            }
            if(isset($_POST['name_filter']) && $_POST['name_filter'] != '')
            {
                $filter['name'] = $_POST['name_filter'];
            }
            if(isset($_POST['isbn_filter']) && $_POST['isbn_filter'] != '')
            {
                $filter['isbn'] = $_POST['isbn_filter'];
            }
            if(isset($_POST['category_filter']) && $_POST['category_filter'] != '')
            {
                $filter['category'] = $_POST['category_filter'];
            }
            $this->data['filter'] = $filter;
        }

        elseif(isset($_GET['cat']))
        {
            $filter['category'] = $_GET['cat'];
            $this->data['filter'] = $filter;
        }

        $this->data['books'] = $modal->get_books($filter, $limit);
        $count = count( $modal->get_books($filter));

        $this->data['modal'] = $modal;
        $this->error['error_code'] = $modal->flag;
        $this->error['message'] = $modal->message;

        if($page > 1)
        {
            $this->data['pagination_link'] .= '<button type="submit" name="filter" class="previous" value="'.($page - 1).'">Previous</button>';
        }
        if($count > count($this->data['books']) * $page && count($this->data['books']) > 0)
        {
            $this->data['pagination_link'] .= '<button type="submit" name="filter" class="next" value="'.($page + 1).'">Next</button>';
        }


        $this->data['category'] = $modal->get_categories();



        $this->data['page_title'] = __('Home | Library Management System');

        $this->view('header', 'front/templates');
        $this->view('home', 'front/templates');
        $this->view('footer', 'front/templates');
	}

	
    public function actionContact()
    {
        $modal = $this->model('settings');

        $this->data['settings'] = $modal->get_settings();

        $email = (isset($this->data['settings'][0]->email) && $this->data['settings'][0]->email != '') ? $this->data['settings'][0]->email : ADMIN_EMAIL;

        if(isset($_POST['submit']))
        {
            if(!$this->check_form($_POST, ['contact_name' => 'Name', 'email' => 'Email', 'message' => 'Message']))
            {
                $this->error['error_code'] = ERROR;
                $this->error['message'] = $this->message;
            }
            elseif($this->check_data($_POST['email'], 'email') == false)
            {
                $this->error['error_code'] = ERROR;
                $this->error['message'] = __('Valid email required');
            }
            else
            {
                $_POST['message'] = 'Name : '.$_POST['contact_name'].'<br>Email : '.$_POST['email'].'<br>'.'Message : '.$_POST["message"];
                if ($this->send_mail($email, __('Contact form'), $_POST['message'])) 
                {
                    // when mail has been send successfully
                    $this->error['error_code'] = SUCCESS;
                    $this->error['message'] = __('Thank you for your query. We will contact you as soon as possible.');
                }
                else 
                {
                     
                      $this->error['error_code'] = ERROR;
                      $this->error['message'] = __("Could not send email.");
                }
            }
        }

        $this->view('header', 'front/templates');
        $this->view('contact', 'front/templates');
        $this->view('footer', 'front/templates');

    }


    function actionEbooks($page = 1) {

        $modal = $this->model('books');

        if(isset($_GET['cat']))
            $this->prg('prg_data',SITE_URL.'default/ebooks/?cat='.$_GET['cat']);
        else
            $this->prg('prg_data',SITE_URL.'default/ebooks/');

        $filter = array();
        $limit = 'limit 0,'.$this->pagination_limit;
        $this->data['pagination_link'] = '';

        if(isset($_POST['pagination']))
        {
            $page = (int)$_POST['filter'];
        }
        if($page > 1)
        {
            $limit = 'limit '.(($page * $this->pagination_limit) - $this->pagination_limit).','.($this->pagination_limit);
        }

        if(isset($_POST['filter']))
        {

            if(isset($_POST['author_filter']) && $_POST['author_filter'] != '')
            {
                $filter['author'] = $_POST['author_filter'];
            }
            if(isset($_POST['name_filter']) && $_POST['name_filter'] != '')
            {
                $filter['name'] = $_POST['name_filter'];
            }
            if(isset($_POST['isbn_filter']) && $_POST['isbn_filter'] != '')
            {
                $filter['isbn'] = $_POST['isbn_filter'];
            }
            if(isset($_POST['category_filter']) && $_POST['category_filter'] != '')
            {
                $filter['category'] = $_POST['category_filter'];
            }
            $this->data['filter'] = $filter;
        }

        elseif(isset($_GET['cat']))
        {
            $filter['category'] = $_GET['cat'];
            $this->data['filter'] = $filter;
        }

        $this->data['books'] = $modal->get_ebooks($filter, $limit);
        $count = count( $modal->get_ebooks($filter));

        $this->data['modal'] = $modal;
        $this->error['error_code'] = $modal->flag;
        $this->error['message'] = $modal->message;

        if($page > 1)
        {
            $this->data['pagination_link'] .= '<button type="submit" name="filter" class="previous" value="'.($page - 1).'">Previous</button>';
        }
        if($count > count($this->data['books']) * $page && count($this->data['books']) > 0)
        {
            $this->data['pagination_link'] .= '<button type="submit" name="filter" class="next" value="'.($page + 1).'">Next</button>';
        }


        $this->data['category'] = $modal->get_categories();



        $this->data['page_title'] = __('Home | Library Management System');

        $this->view('header', 'front/templates');
        $this->view('ebooks', 'front/templates');
        $this->view('footer', 'front/templates');
    }

    function actionDownload()
    {
        if (isset($_GET['file'])) {
            $_SESSION['file'] = $_GET['file'];
            $model = $this->model('books');
            $result = $model->get_ebook_by_id($_GET['file']);

            if($model->flag === ERROR || $model->flag === WARNING || $model->flag === NOTICE) {
                $this->error['error_code'] = $model->flag;              
                $this->error['message'] = $model->message;
                return;
            }
            else
            {
                    $ref = $_SESSION['file'];
                    unset($_SESSION['file']);               
                    header("Refresh:2; url=".SITE_URL."files/download/?file=".$ref);
            }
        }

        
        $this->view('header', 'front/templates');
        $this->view('thankyou', 'front/templates');
        $this->view('footer', 'front/templates');

    }

}



?>