<?php

class homeController extends Controller {
	private $model;

	function __construct() {
		session::check('user_id', SITE_URL.'login/');
        if(session::get('user_role') != 'A')
        {            
            session::clean_session(SITE_URL.'login/');
            die();
        }

        $this->data['footer'] = $this->model('settings')->get_settings()[0]->institute_name;
        $this->data['footer_address'] = $this->model('settings')->get_settings()[0]->address;
        $this->data['logo'] = $this->model('settings')->get_settings()[0]->logo;
	}


	function actionLogout() {
		session::clean_session(SITE_URL);
	}

	function actionMain() {

		$modal = $this->model('books');

        $this->data['internet'] = $this->is_connected();

        $this->data['total_books'] = count($modal->get_books());
        $this->data['total_issued'] = count($this->model('issue')->get_issued());
        $this->data['total_lost'] = count($this->model('issue')->get_lost());
        $this->data['total_returned'] = count($this->model('issue')->get_returned());
        $this->data['total_students'] = count($this->model('users')->get_users_count('', 'S'));
        $this->data['total_members'] = count($this->model('users')->get_users_count('', 'T'));

        $this->data['today_books'] = count($modal->get_books_count('today'));
        $this->data['today_fine'] = $this->model('issue')->get_fine_count()->total_fine;
        $this->data['today_issued'] = count($this->model('issue')->get_issued_count());
        $this->data['today_lost'] = count($this->model('issue')->get_lost_count());
        $this->data['today_returned'] = count($this->model('issue')->get_returned_count());

        $this->data['month_books'] = count($modal->get_books_count('month'));
        $this->data['month_fine'] = $this->model('issue')->get_fine_count('month')->total_fine;
        $this->data['month_issued'] = count($this->model('issue')->get_issued_count('month'));
        $this->data['month_lost'] = count($this->model('issue')->get_lost_count('month'));
        $this->data['month_returned'] = count($this->model('issue')->get_returned_count('month'));

        $this->data['year_books'] = count($modal->get_books_count('year'));
        $this->data['year_fine'] = $this->model('issue')->get_fine_count('year')->total_fine;
        $this->data['year_issued'] = count($this->model('issue')->get_issued_count('year'));
        $this->data['year_lost'] = count($this->model('issue')->get_lost_count('year'));
        $this->data['year_returned'] = count($this->model('issue')->get_returned_count('year'));

        $this->data['page_title'] = __('Home | Library Management System');

        $this->view('header');
        $this->view('dashboard','home');
        $this->view('footer');
	}

	function actionSettings() {

		$model = $this->model('settings');
		if(isset($_POST['submit']))
        {
            if($_POST['security_token'] !== $_SESSION['token']) 
            {
                $this->error['message'] = 'Token Mismatch';
                $this->error['error_code'] = ERROR;
            }
            else
            {
                $result = $model->process_setting();

				$this->error['error_code'] = $model->flag;
				$this->error['message'] = $model->message;
            }
           
        }
/**
 *
 *
 *
 * Generate security token to handle double form submissions
 *
 *
 *
 **/
        $this->data['token'] = md5(uniqid(rand(), TRUE).time());
        $_SESSION['token'] = $this->data['token'];

		$this->data['settings'] = $model->get_settings();

        $this->data['page_title'] = __('Setting | Library Management System');

		$this->view('header');
		$this->view('settings','home');
		$this->view('footer');
	}

    function actionChangePassword() {

        if(Helpers::isAjax())
        {
            $modal = $this->model('settings');

            $modal->process_password();

            $response = ($modal->flag == SUCCESS) ? '<div class="msg success"><p>'.$modal->message.'</p></div>' : '<div class="msg fail"><p>'.$modal->message.'</p></div>' ;
            $code = $modal->flag;

            echo json_encode(array('text'=>$response, 'code'=>$code));
        }
    }

    function actionChangeUsername() {

        if(Helpers::isAjax())
        {
            $modal = $this->model('settings');

            $modal->process_username();

            $response = ($modal->flag == SUCCESS) ? '<div class="msg success"><p>'.$modal->message.'</p></div>' : '<div class="msg fail"><p>'.$modal->message.'</p></div>' ;
            $code = $modal->flag;

            echo json_encode(array('text'=>$response, 'code'=>$code));
        }
    }
    private function is_connected()
    {
        $connected = @fsockopen("www.operce.com", 80); 
                                            //website, port  (try 80 or 443)
        if ($connected){
            $is_conn = true; //action when connected
            fclose($connected);
        }else{
            $is_conn = false; //action in connection failure
        }
        return $is_conn;

    }

}



?>