<?php

class notificationsController extends Controller {
    
    private $model;
    private $pagination_limit = 10;
    private $pagination_buttons;

    
    function __construct() { 
        $this->pagination_buttons = array(__('Prevoius'), __('Next'));
        session::check('user_id', SITE_URL.'login/');
        if(session::get('user_role') != 'A')
        {            
            session::clean_session(SITE_URL.'login/');
            die();
        }

        $this->data['footer'] = $this->model('settings')->get_settings()[0]->institute_name;
        $this->data['footer_address'] = $this->model('settings')->get_settings()[0]->address;
        $this->data['logo'] = $this->model('settings')->get_settings()[0]->logo;
    }

    function actionMain($page = 1)
    {
        $modal = $this->model('issue');

        if(isset($_GET['export']))
        {
            $modal->process_export('delayed');
        }
        else
        {
            $this->prg('prg_data',SITE_URL.'notifications/');
            $filter = array();
            $limit = 'limit 0,'.$this->pagination_limit;
            $this->data['pagination_link'] = '';

            if(isset($_POST['pagination']))
            {
                $page = (int)$_POST['filter'];
            }
            if($page > 1)
            {
                $limit = 'limit '.(($page * $this->pagination_limit) - $this->pagination_limit).','.($this->pagination_limit);
            }

            if(isset($_POST['filter']))
            {

                if(isset($_POST['from_filter']) && $_POST['from_filter'] != '')
                {
                    $filter['from'] = $_POST['from_filter'];
                }
                if(isset($_POST['to_filter']) && $_POST['to_filter'] != '')
                {
                    $filter['to'] = $_POST['to_filter'];
                }
                $this->data['filter'] = $filter;
            }

            $this->data['books'] = $modal->get_delayed($filter, $limit);
            $count = count( $modal->get_delayed($filter));

            if($page > 1)
            {
                $this->data['pagination_link'] .= '<button type="submit" name="filter" class="previous" value="'.($page - 1).'">Previous</button>';
            }
            if($count > count($this->data['books']) * $page && count($this->data['books']) > 0)
            {
                $this->data['pagination_link'] .= '<button type="submit" name="filter" class="next" value="'.($page + 1).'">Next</button>';
            }

            $this->data['page_title'] = __('Notifications | Library Management System');
            $this->data['currency'] = $this->model('settings')->get_currency()->currency;

            $this->view('header');
            $this->view('notify','notifications');
            $this->view('footer');
        }
    }

    function actionNotify()
    {
        if(Helpers::isAjax())
        {
            $modal = $this->model('issue');

            $modal->process_notify();

            $response = ($modal->flag == SUCCESS) ? '<div class="msg success"><p>'.$modal->message.'</p></div>' : '<div class="msg fail"><p>'.$modal->message.'</p></div>' ;
            $code = $modal->flag;

            echo json_encode(array('text'=>$response, 'code'=>$code));
        }
    }
}
?>