<?php

class othersController extends Controller {
    
    private $model;
    
    function __construct() {
        session::check('user_id', SITE_URL.'login/');
        if(session::get('user_role') != 'A')
        {            
            session::clean_session(SITE_URL.'login/');
            die();
        }

        $this->data['footer'] = $this->model('settings')->get_settings()[0]->institute_name;
        $this->data['footer_address'] = $this->model('settings')->get_settings()[0]->address;
        $this->data['logo'] = $this->model('settings')->get_settings()[0]->logo;
    }

    function actionMain()
    {
        $modal_category = $this->model('category');
        $modal_class = $this->model('classes');
        $modal_designation = $this->model('designation');


        if(isset($_GET['type']) && isset($_GET['delete']))
        {
            if($_GET['type'] == 'category')
            {
                $modal_category->delete_category($_GET['delete']);
                $this->redirect(SITE_URL.'others/');
            }
            elseif($_GET['type'] == 'class')
            {
                $modal_class->delete_class($_GET['delete']);
                $this->redirect(SITE_URL.'others/');
            }
            elseif($_GET['type'] == 'designation')
            {
                $modal_designation->delete_designation($_GET['delete']);
                $this->redirect(SITE_URL.'others/');
            }
        }

        $this->data['categories'] = $modal_category->get_categories();
        $this->data['class'] = $modal_class->get_class();
        $this->data['designations'] = $modal_designation->get_designation();

        $this->data['total_categories'] = count($this->data['categories']);
        $this->data['total_class'] = count($this->data['class']);
        $this->data['total_designations'] = count($this->data['designations']);

        $this->view('header');
        $this->view('dashboard','categories');
        $this->view('footer');
    }

    function actionAddCategory()
    {
        if(Helpers::isAjax())
        {
            $modal = $this->model('category');

            $modal->process_category();

            $response = ($modal->flag == SUCCESS) ? '<div class="msg success"><p>'.$modal->message.'</p></div>' : '<div class="msg fail"><p>'.$modal->message.'</p></div>' ;
            $code = $modal->flag;

            echo json_encode(array('text'=>$response, 'code'=>$code));
        }
    }

    function actionAddClass()
    {
        if(Helpers::isAjax())
        {
            $modal = $this->model('classes');

            $modal->process_class();

            $response = ($modal->flag == SUCCESS) ? '<div class="msg success"><p>'.$modal->message.'</p></div>' : '<div class="msg fail"><p>'.$modal->message.'</p></div>' ;
            $code = $modal->flag;

            echo json_encode(array('text'=>$response, 'code'=>$code));
        }
    }

    function actionAddDesignation()
    {
        if(Helpers::isAjax())
        {
            $modal = $this->model('designation');

            $modal->process_designation();

            $response = ($modal->flag == SUCCESS) ? '<div class="msg success"><p>'.$modal->message.'</p></div>' : '<div class="msg fail"><p>'.$modal->message.'</p></div>' ;
            $code = $modal->flag;

            echo json_encode(array('text'=>$response, 'code'=>$code));
        }
    }
    


}
?>