<?php
/**
 * File contains necessary information that defines the bootstrap of your application
 * Source code pattern must not be modified
 * Files to be used with the comments.
 * @Author : Operce Technologies
 * @Developer : Manhar Sharma
 * @Year : 2016
 *
 *
 **/


/**
 * class for login
 * pattern must not be modified
 * Files to be used with the comments.
 *
 *
 */

defined('_DONUT') or die('Error. Invalid Access');

class books extends Model {
    public $page_title;
    public $message;
    public $flag;
    public $values;
    private $crud;

    function __construct() {
        $this->crud = new crud('lms_books');
    }

    function process_book() {
        $this->values = $_POST;
        if(!$this->check_form($this->values, ['isbn'=>'ISBN', 'book_name'=>'Book name', 'barcode_id'=>'Barcode ID', 'description' => 'Description', 'language' => 'Language', 'category' => 'Category', 'publisher' => 'Publisher', 'year' => 'Year', 'author' => 'Author',  'location' => 'Location', 'quantity' => 'Quantity'], '{description},{language},{location}')) {
            $this->flag = ERROR;
            return false;
        }
        if($this->processaddfile() == false) {
            return false;
        }
        if($this->values['quantity'] <= 0)
        {
            $this->flag = WARNING;
            $this->message = __('Quantity must be above 0(Zero).');
            return false;
        }

        $this->add_book();
    }

    function get_categories($type = false, $obj = false) {
        if($type != false)
        {
            if(is_numeric($type))
            {
                $this->crud->changeTable('lms_categories');
                $data = $this->crud->get_by( array('id' => $type), '=', true);
                $this->crud->changeTable('lms_books');
                
                if(!empty($data))
                {
                    if($obj == false)
                        return true;
                    else
                        return $data;
                }
                else
                {
                    return false;
                }
            }
            else
            {
                return false;
            }
        }
        else
        {
            $this->crud->changeTable('lms_categories');
            $data = $this->crud->get_all();
            $this->crud->changeTable('lms_books');
            return $data;
        }
    }

    function get_issue_count($book_id,$book_count = false)
    {
        $query = "select * from lms_issue where book_id = :book_id AND status = 'issue'";
        $count = $this->crud->exec_query($query, array(':book_id' => $book_id))->fetchAll(PDO::FETCH_CLASS);

        if($book_count == false)
        {
            return count($count);
        }
        else
        {
            if(($book_count - count($count)) <= 0)
            {
                return false;
            }
            return true;
        }
    }


    function get_books($filter = array(), $limit = false) {

        $out_books = $this->crud->get_by( array( 'quantity' => 1 ), '<' );

        if(count($out_books) > 0)
        {
            $this->flag = WARNING;
            $this->message = count($out_books).__(' books out of stock.');
        }

        $query = 'select * from lms_books';
        $flag = false;

        if(isset($filter['name']))
        {
            if(!$this->check_form($filter, ['name'=>'Name'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND name like '%".$filter['name']."%'" : $query . " where name like '%".$filter['name']."%'" ;
            if($flag == false) $flag = true;
        }
        if(isset($filter['isbn']))
        {
            if(!$this->check_form($filter, ['isbn'=>'ISBN'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND isbn = '".$filter['isbn']."'" : $query . " where isbn = '".$filter['isbn']."'";
            if($flag == false) $flag = true;
        }
        if(isset($filter['author']))
        {
            if(!$this->check_form($filter, ['author' => 'Author'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND author like '%".$filter['author']."%'" : $query . " where author like '%".$filter['author']."%'";
            if($flag == false) $flag = true;
        }
        if(isset($filter['barcode']))
        {
            if(!$this->check_form($filter, ['barcode'=>'Barcode ID'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND barcode_id = '".$filter['barcode']."'" : $query . " where barcode_id = '".$filter['barcode']."'";
            if($flag == false) $flag = true;
        }
        if(isset($filter['category']))
        {
            if(!$this->check_form($filter, ['category' => 'Category'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND category = '".$filter['category']."'" : $query . " where category = '".$filter['category']."'";
            if($flag == false) $flag = true;
        }
        
        if($limit != false)
        {
            $query = $query.' '.$limit;
        }
        
        $data = $this->crud->exec_query($query)->fetchAll(PDO::FETCH_CLASS);
        return $data;
    }

    function get_books_by_id() {
            $query = 'select lms_books.name as book_name, lms_books.*, lms_users.name as issued_to,lms_users.email as email,lms_users.*,lms_issue.id as issue_id, lms_issue.* from lms_issue inner join lms_books on lms_issue.book_id = lms_books.book_id inner join lms_users on lms_issue.user_id = lms_users.user_id where lms_users.user_id = '.session::get('user_id');
            $query = $query . " and (lms_issue.status = 'issue')";            

            $data = $this->crud->exec_query($query)->fetchAll(PDO::FETCH_CLASS);
            return $data;
    }

    function get_requested_books() {
            $query = 'select lms_books.name as book_name, lms_books.*, lms_users.name as issued_to,lms_users.email as email,lms_users.*,lms_requested.id as requested_id, lms_requested.* from lms_requested inner join lms_books on lms_requested.book_id = lms_books.book_id inner join lms_users on lms_requested.user_id = lms_users.user_id where lms_users.user_id = '.session::get('user_id');          

            $data = $this->crud->exec_query($query)->fetchAll(PDO::FETCH_CLASS);
            return $data;
    }

    function get_books_count($args = 'today') {

        if($args == 'today')
        {
            $query = 'SELECT * FROM lms_books WHERE date >= CURDATE()';
            $flag = false;
        }
        elseif($args == 'month')
        {
            $query = 'SELECT * FROM lms_books WHERE MONTH(date) = MONTH(CURDATE())';
            $flag = false;
        }
        elseif($args == 'year')
        {
            $query = 'SELECT * FROM lms_books WHERE YEAR(date) = YEAR(CURDATE())';
            $flag = false;
        }
        
        $data = $this->crud->exec_query($query)->fetchAll(PDO::FETCH_CLASS);
        return $data;
    }
    
    function get_out_stock($filter = array(), $limit = false) {

        $query = 'select * from lms_books where quantity <= 0';


        if(isset($filter['name']))
        {

            $query = $query . " AND name like '%".$filter['name']."%'";
        }
        if(isset($filter['isbn']))
        {
            $query = $query . " AND isbn = '".$filter['isbn']."'";
        }
        if(isset($filter['author']))
        {
            $query = $query . " AND author like '%".$filter['author']."%'";
        }
        if(isset($filter['barcode']))
        {
            $query = $query. " AND barcode_id = '".$filter['barcode']."'";
        }
        if(isset($filter['category']))
        {
            $query = $query . " AND category = '".$filter['category']."'";
        }
        
        if($limit != false)
        {
            $query = $query.' '.$limit;
        }
        
        $data = $this->crud->exec_query($query)->fetchAll(PDO::FETCH_CLASS);
        return $data;
    }

    private function add_book() {
        $dt = new DateTime();
        $date = $dt->format('Y-m-d H:i:s');
        $args = array('isbn'=>$this->values['isbn'], 'name'=>$this->values['book_name'], 'barcode_id'=>$this->values['barcode_id'], 'description' => $this->values['description'], 'language' => $this->values['language'], 'category' => $this->values['category'], 'publisher' => $this->values['publisher'], 'published_year' => $this->values['year'], 'author' => $this->values['author'], 'location' => $this->values['location'], 'quantity' => $this->values['quantity'], 'photo' => $this->values['download_file'], 'date' => $date);
        $data_prev = $this->crud->get_by( array('barcode_id' => $this->values['barcode_id']), '=', true );

        if(!empty($data_prev))
        {
            $args['quantity'] += $data_prev->quantity;

            if($this->values['download_file'] != '')
            {
                $cover = $this->crud->get_by( array( 'book_id' => $data_prev->book_id ), '=', true);
                $cover = $cover->photo;
                if($cover != '')
                    unlink($cover);
            }

            $data = $this->crud->update( $args, array( 'book_id' => $data_prev->book_id ));
            
            if($data > 0)
            {
                $this->flag = SUCCESS;
                $this->message = __(' Books updated');
                return true;
            }
            else
            {
                $this->flag = WARNING;
                $this->message = __("Books weren't updated");
                return true;
            }
        }
        else
        {
            $data = $this->crud->insert( $args );
        
            if($data > 0)
            {
                $this->flag = SUCCESS;
                $this->message = __(' Book Added');
                return true;
            }
            else
            {
                $this->flag = ERROR;
                $this->message = __("Error adding Book");
                return true;
            }
        }
        
    }

    function processaddfile()
    {
        $name = $this->name_generator();
        $this->values['download_file'] = '';
        if(isset($_FILES['files']) && $_FILES['files']['name'] != '') {
            $this->values['download_file'] = $_FILES['files'];
            $target_file = basename($this->values["download_file"]["name"]);
            $imageFileType = pathinfo($target_file,PATHINFO_EXTENSION);
            if ($this->values["download_file"]["size"] > 2010000) {
                    $this->flag = ERROR;
                    $this->message = __("File is too large");
                    return false;
                }
                // Allow certain file formats
                if($imageFileType != "jpg" && $imageFileType != "png" && $imageFileType != "JPG" && $imageFileType != "PNG" && $imageFileType != "jpeg"
                && $imageFileType != "gif" ) {
                    $this->flag = ERROR;
                    $this->message = __("Valid file is required");
                    return false;
                }



            $target_dir = "public/uploads/";
            $temp = explode(".", $this->values["download_file"]["name"]);
            $filenoext = $this->name_generator();
            $newfilename1 = $filenoext . '.' . end($temp);

            if (move_uploaded_file($this->values["download_file"]["tmp_name"], $target_dir.$newfilename1)) {
                $this->values['download_file'] = $target_dir.$newfilename1;
                return true;

            }
            else {
                $this->flag = ERROR;
                $this->message = __("Files could not be uploaded");
                return false;
            }
        }
        else
            return true;
    }


    function delete_book($id)
    {
        $con = $this->crud->get_connection();

        $con->beginTransaction();

        try
        {
            $data = $this->crud->delete( array('book_id' => $id) );
            
            $this->crud->changeTable('lms_issue');
            $data = $this->crud->delete( array('book_id'=>$id) );

            $con->commit();

            $this->flag = SUCCESS;
            $this->message = __('Data Deleted');
            return true;
        }
        catch(Exception $e)
        {
            $con->rollBack();
            $this->flag = ERROR;
            $this->message = __("Error deleting details. Error : "). $e->getMessage();
            return true;
        }
    }

    function update_book($single = false)
    {
        $this->values = $_POST;
        
        if($single == false)
        {

            if(!$this->check_form($this->values, ['book_name'=>'Book name', 'isbn'=>'ISBN', 'description'=>'description', 'publisher' => 'publisher', 'author' => 'author','location' => 'Location', 'quantity' => 'quantity'], '{description},{language},{location}')) {
                $this->flag = ERROR;
                return false;
            }

            if($this->processaddfile() == false) {
                $this->values['download_file'] = '';
            }

            if($this->values['quantity'] <= 0)
            {
                $this->flag = ERROR;
                $this->message = __('Quantity is too low');
                return false;
            }
            $con = $this->crud->get_connection();

            $con->beginTransaction();

            try
            {
                if($this->values['download_file'] == '')
                    $args = array('isbn'=>$this->values['isbn'], 'name'=>$this->values['book_name'], 'description' => $this->values['description'], 'publisher' => $this->values['publisher'], 'author' => $this->values['author'], 'location' => $this->values['location'], 'quantity' => $this->values['quantity']);
                else
                    $args = array('isbn'=>$this->values['isbn'], 'name'=>$this->values['book_name'], 'description' => $this->values['description'], 'publisher' => $this->values['publisher'], 'author' => $this->values['author'], 'location' => $this->values['location'], 'quantity' => $this->values['quantity'], 'photo' => $this->values['download_file']);
                

                if($this->values['download_file'] != '')
                {
                    $cover = $this->crud->get_by( array( 'book_id' => $this->values['id'] ), '=', true);
                    $cover = $cover->photo;
                    if($cover != '')
                        unlink($cover);
                }

                $data = $this->crud->update( $args, array('book_id' => $this->values['id']) );
                
                $con->commit();

                $this->flag = SUCCESS;
                $this->message = __(' Book updated');
                return true;
            }
            catch(Exception $e)
            {
                $con->rollBack();
                $this->flag = ERROR;
                $this->message = __("Error updating book. Error : "). $e->getMessage();
                return true;
            }
        }
        elseif($single == 'single')
        {

            if(!$this->check_form($this->values, ['quantity' => 'quantity'])) {
                $this->flag = ERROR;
                return false;
            }

            if($this->values['quantity'] <= 0)
            {
                $this->flag = ERROR;
                $this->message = __('Quantity is too low');
                return false;
            }
            $con = $this->crud->get_connection();

            $con->beginTransaction();

            try
            {
                $args = array('quantity' => $this->values['quantity']);
            
                $data = $this->crud->update( $args, array('book_id' => $this->values['id']) );
                
                $con->commit();

                $this->flag = SUCCESS;
                $this->message = __(' Book updated');
                return true;
            }
            catch(Exception $e)
            {
                $con->rollBack();
                $this->flag = ERROR;
                $this->message = __("Error updating book. Error : "). $e->getMessage();
                return true;
            }
        }
        elseif($single = 'all')
        {

            if(!$this->check_form($this->values, ['book_name'=>'Book name', 'description' => 'Description', 'language' => 'Language', 'category' => 'Category', 'publisher' => 'Publisher', 'year' => 'Year', 'author' => 'Author',  'location' => 'Location', 'quantity' => 'Quantity'], '{description},{language},{location}')) {
                $this->flag = ERROR;
                return false;
            }

            if($this->processaddfile() == false) {
                $this->values['download_file'] = '';
            }

            if($this->values['quantity'] <= 0)
            {
                $this->flag = ERROR;
                $this->message = __('Quantity is too low');
                return false;
            }
            $con = $this->crud->get_connection();

            $con->beginTransaction();

            try
            {
                if($this->values['download_file'] == '')
                    $args = array('name'=>$this->values['book_name'], 'description' => $this->values['description'], 'language' => $this->values['language'], 'category' => $this->values['category'], 'publisher' => $this->values['publisher'], 'published_year' => $this->values['year'], 'author' => $this->values['author'], 'location' => $this->values['location'], 'quantity' => $this->values['quantity']);
                else
                   $args = array('name'=>$this->values['book_name'], 'description' => $this->values['description'], 'language' => $this->values['language'], 'category' => $this->values['category'], 'publisher' => $this->values['publisher'], 'published_year' => $this->values['year'], 'author' => $this->values['author'], 'location' => $this->values['location'], 'quantity' => $this->values['quantity'], 'photo' => $this->values['download_file']);
                


                if($this->values['download_file'] != '')
                {
                    $cover = $this->crud->get_by( array( 'book_id' => $this->values['id'] ), '=', true);
                    $cover = $cover->photo;
                    if($cover != '')
                        unlink($cover);
                }


                $data = $this->crud->update( $args, array('book_id' => $this->values['id']) );
                
                $con->commit();

                $this->flag = SUCCESS;
                $this->message = __(' Book updated');
                return true;
            }
            catch(Exception $e)
            {
                $con->rollBack();
                $this->flag = ERROR;
                $this->message = __("Error updating book. Error : "). $e->getMessage();
                return true;
            }
        }
        
    }


    function process_import()
    {
        if(isset($_FILES['csv_file']))
        {
            $imageFileType = pathinfo(basename($_FILES["csv_file"]["name"]),PATHINFO_EXTENSION);

            if($imageFileType != "CSV" && $imageFileType != "csv") {
                $this->flag = ERROR;
                $this->message = __("Valid CSV is required");
                return false;
            }
                $flag = true;
                $filename =  $_FILES['csv_file']['tmp_name'];
                $file = fopen($filename, "r");
                $count = 0;
                while (($getData = fgetcsv($file)) !== FALSE)
                 {
                    if($count <= 0)
                    {
                        $count++;
                        continue;
                    }
                    if(count($getData) < 11)
                    {

                        $this->flag = ERROR;
                        $flag = false;
                        if(isset($this->message))
                             $this->message .= __("Invalid CSV data at line : ").($count+1).'<br>';
                        else
                            $this->message = __("Invalid CSV data at line : ").($count+1).'<br>';

                        $count++;
                        continue;
                    }
                    $name = $getData[0];
                    $isbn = $getData[1];
                    $description = $getData[2];
                    $language = $getData[3];
                    $publisher = $getData[4];
                    $published_year = $getData[5];
                    $barcode_id = $getData[6];
                    $category = $getData[7];
                    $location = $getData[8];
                    $quantity = $getData[9];
                    $author = $getData[10];

                    if($this->check_data($isbn, 'int') == false || $this->check_data($barcode_id, 'int') == false || $this->check_data($category, 'int') == false || $this->check_data($quantity, 'int') == false)
                    {
                        $this->flag = ERROR;
                        $flag = false;
                        if(isset($this->message))
                             $this->message .= __("Invalid CSV data at line : ").($count+1).'<br>';
                        else
                            $this->message = __("Invalid CSV data at line : ").($count+1).'<br>';


                        $count++;
                        continue;
                    }

                    if($this->get_categories($category) == false)
                    {
                        $this->flag = ERROR;
                        $flag = false;
                        if(isset($this->message))
                             $this->message .= __("Invalid CSV data at line : ").($count+1).'<br>';
                        else
                            $this->message = __("Invalid CSV data at line : ").($count+1).'<br>';


                        $count++;
                        continue;
                    }

                    $data_prev = $this->crud->get_by( array('barcode_id' => $barcode_id), '=', true );
                    if(!empty($data_prev) > 0)
                    {
                        $count++;

                        if(isset($this->message))
                             $this->message .= __("Book exists for barcode").$barcode_id.__(" at line : ").($count+1).'<br>';
                        else
                            $this->message = __("Book exists for barcode").$barcode_id.__(" at line : ").($count+1).'<br>';
                        continue;
                    }

                    $query = "insert into lms_books(name, isbn, description, language, publisher, published_year, barcode_id,category,location,quantity, author)
                            values (:name, :isbn, :description, :language, :publisher, :published_year, :barcode_id,:category,:location,:quantity, :author) ";
                    
                    $markers = array(':name' => $name, ':isbn' => $isbn, ':description' =>  $description, ':language' => $language, ':publisher' => $publisher, ':published_year' => $published_year, ':barcode_id' => $barcode_id,':category' => $category,':location' => $location,':quantity' =>  $quantity, ':author' => $author);


                    $this->crud->exec_query($query,$markers);

                    $data = $this->crud->get_connection()->lastInsertId();
                    
                    if(!empty($data))
                    {
                        $this->flag = SUCCESS;
                    }
                    else
                    {
                        $this->flag = ERROR;
                        $flag = false;
                        if(isset($this->message))
                             $this->message .= __("Error Inserting book"). ($count+1).'<br>';
                        else
                            $this->message = __("Error Inserting book"). ($count+1).'<br>';
                    }

                    $count++;
                }
                
                fclose($file); 
                if($this->flag == SUCCESS)
                { 
                    $this->message = __("Books imported successfully");
                    return true;
                }
                else return false;
        }

        return true;

    }

    function process_export()
    {
            header('Content-Type: text/csv; charset=utf-8');  
            header('Content-Disposition: attachment; filename=data.csv');  
            $output = fopen("php://output", "w+");  
            fputcsv($output, array('name', 'isbn', 'description', 'language', 'publisher', 'published_year', 'barcode_id', 'category', 'location', 'quantity', 'author'));  
            $query = "SELECT name,isbn,description,language,publisher,published_year,barcode_id,category,location,quantity,author from lms_books";

            $flag = false;

            if(isset($filter['name']))
            {
                if(!$this->check_form($filter, ['name'=>'Name'])) {
                    $this->flag = ERROR;
                    return false;
                }
                $query = ($flag == true) ? $query . " AND name like '%".$filter['name']."%'" : $query . " where name like '%".$filter['name']."%'" ;
                if($flag == false) $flag = true;
            }
            if(isset($filter['isbn']))
            {
                if(!$this->check_form($filter, ['isbn'=>'ISBN'])) {
                    $this->flag = ERROR;
                    return false;
                }
                $query = ($flag == true) ? $query . " AND isbn = '".$filter['isbn']."'" : $query . " where isbn = '".$filter['isbn']."'";
                if($flag == false) $flag = true;
            }
            if(isset($filter['author']))
            {
                if(!$this->check_form($filter, ['author' => 'Author'])) {
                    $this->flag = ERROR;
                    return false;
                }
                $query = ($flag == true) ? $query . " AND author like '%".$filter['author']."%'" : $query . " where author like '%".$filter['author']."%'";
                if($flag == false) $flag = true;
            }
            if(isset($filter['barcode']))
            {
                if(!$this->check_form($filter, ['barcode'=>'Barcode ID'])) {
                    $this->flag = ERROR;
                    return false;
                }
                $query = ($flag == true) ? $query . " AND barcode_id = '".$filter['barcode']."'" : $query . " where barcode_id = '".$filter['barcode']."'";
                if($flag == false) $flag = true;
            }
            if(isset($filter['category']))
            {
                if(!$this->check_form($filter, ['category' => 'Category'])) {
                    $this->flag = ERROR;
                    return false;
                }
                $query = ($flag == true) ? $query . " AND category = '".$filter['category']."'" : $query . " where category = '".$filter['category']."'";
                if($flag == false) $flag = true;
            }

            $smt = $this->crud->get_connection()->prepare($query);
            $smt->execute();

            while($row = $smt->fetch(PDO::FETCH_ASSOC))  
            {  
               fputcsv($output, $row);  
            }  
            fclose($output);  
    }

    function check_book($book_id)
    {
        $query = 'select * from lms_books where book_id = :book_id';
        $book = $this->crud->exec_query($query, array(':book_id' => $book_id))->fetchAll(PDO::FETCH_CLASS);
        
        if(count($book) <= 0)
        {
            $this->flag = ERROR;
            $this->message = __("Invalid access");
            return false;
        }
        return $book[0];
    }


     function process_ebook() {
        $this->values = $_POST;
        if(!$this->check_form($this->values, ['isbn'=>'ISBN', 'book_name'=>'Book name', 'description' => 'Description', 'language' => 'Language', 'category' => 'Category', 'publisher' => 'Publisher', 'year' => 'Year', 'author' => 'Author'], '{description},{language}')) {
            $this->flag = ERROR;
            return false;
        }
        if($this->processaddfile() == false) {
            return false;
        }
        $this->values['photo'] = $this->values['download_file'];
        if($this->processaddebookfile() == false) {
            return false;
        }
        $this->add_ebook();
    }

function get_ebooks($filter = array(), $limit = false) {

        $query = "select * from lms_ebooks ";
        $flag = false;

        if(isset($filter['name']))
        {
            if(!$this->check_form($filter, ['name'=>'Name'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND name like '%".$filter['name']."%'" : $query . " where name like '%".$filter['name']."%'" ;
            if($flag == false) $flag = true;
        }
        if(isset($filter['isbn']))
        {
            if(!$this->check_form($filter, ['isbn'=>'ISBN'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND isbn = '".$filter['isbn']."'" : $query . " where isbn = '".$filter['isbn']."'";
            if($flag == false) $flag = true;
        }
        if(isset($filter['author']))
        {
            if(!$this->check_form($filter, ['author' => 'Author'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND author like '%".$filter['author']."%'" : $query . " where author like '%".$filter['author']."%'";
            if($flag == false) $flag = true;
        }
        if(isset($filter['category']))
        {
            if(!$this->check_form($filter, ['category' => 'Category'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND category = '".$filter['category']."'" : $query . " where category = '".$filter['category']."'";
            if($flag == false) $flag = true;
        }
        
        if($limit != false)
        {
            $query = $query.' '.$limit;
        }
        
        $data = $this->crud->exec_query($query)->fetchAll(PDO::FETCH_CLASS);
        return $data;
    }

   private function add_ebook() {

        $dt = new DateTime();
        $date = $dt->format('Y-m-d H:i:s');

        $this->crud->changeTable('lms_ebooks');

        $args = array('isbn'=>$this->values['isbn'], 'name'=>$this->values['book_name'], 'description' => $this->values['description'], 'language' => $this->values['language'], 'category' => $this->values['category'], 'publisher' => $this->values['publisher'], 'published_year' => $this->values['year'], 'author' => $this->values['author'], 'photo' => $this->values['photo'], 'download_file' => $this->values['download_file'], 'date' => $date);
        $data_prev = $this->crud->get_by( array('isbn' => $this->values['isbn']), '=', true );


        $this->crud->changeTable('lms_books');

        if(count($data_prev) > 0)
        {

            $this->flag = WARNING;
            $this->message = __("Book already exists");
            return true;
        }
        else
        {   

            $this->crud->changeTable('lms_ebooks');
            $data = $this->crud->insert( $args );
            $this->crud->changeTable('lms_books');
        
            if($data > 0)
            {
                $this->flag = SUCCESS;
                $this->message = __('Book Added');
                return true;
            }
            else
            {
                $this->flag = ERROR;
                $this->message = __("Error adding Book");
                return true;
            }
        }
        
    }

   function processaddebookfile()
    {
        $name = $this->name_generator();
        $this->values['download_file'] = '';
        if(isset($_FILES['e_file']) && $_FILES['e_file']['name'] != '') {
            $this->values['download_file'] = $_FILES['e_file'];
            $target_file = basename($this->values["download_file"]["name"]);
            $imageFileType = pathinfo($target_file,PATHINFO_EXTENSION);
            if ($this->values["download_file"]["size"] > 2010000) {
                    $this->flag = ERROR;
                    $this->message = __("File is too large");
                    return false;
                }
                // Allow certain file formats                

                if($imageFileType != "pdf" && $imageFileType != "epub" && $imageFileType != "PDF" && $imageFileType != "EPUB" && $imageFileType != "doc"
                && $imageFileType != "DOC" && $imageFileType != "docx" && $imageFileType != "DOCX" && $imageFileType != "pdb" && $imageFileType != "PDB") {
                    $this->flag = ERROR;
                    $this->message = __("Valid ebook file is required");
                    return false;
                }



            $target_dir = "public/uploads/";
            $temp = explode(".", $this->values["download_file"]["name"]);
            $filenoext = $this->name_generator();
            $newfilename1 = $filenoext . '.' . end($temp);

            if (move_uploaded_file($this->values["download_file"]["tmp_name"], $target_dir.$newfilename1)) {
                $this->values['download_file'] = $target_dir.$newfilename1;
                return true;

            }
            else {
                $this->flag = ERROR;
                $this->message = __("Files could not be uploaded");
                return false;
            }
        }
        else
            return true;
    }

    function delete_ebook($id)
    {
        $con = $this->crud->get_connection();

        $con->beginTransaction();

        try
        {
            $this->crud->changeTable('lms_ebooks');

            $data = $this->crud->get_by( array('ebook_id' => $id), '=', true );
            {
                if($data->download_file != '')
                {
                    unlink($data->download_file);
                }
                if($data->photo != '')
                {
                    unlink($data->photo);
                }
            }

            $data = $this->crud->delete( array('ebook_id' => $id) );

            $con->commit();

            $this->crud->changeTable('lms_books');

            $this->flag = SUCCESS;
            $this->message = __('Data Deleted');
            return true;
        }
        catch(Exception $e)
        {
            $con->rollBack();
            $this->flag = ERROR;
            $this->message = __("Error deleting details. Error : "). $e->getMessage();
            return true;
        }
    }

    function update_ebook($single = false)
    {
        $this->values = $_POST;
        
        if($single == false)
        {

            if(!$this->check_form($this->values, ['book_name'=>'Book name', 'isbn'=>'ISBN', 'description'=>'description', 'publisher' => 'publisher', 'author' => 'author'], '{description},{language}')) {
                $this->flag = ERROR;
                return false;
            }

            
            $con = $this->crud->get_connection();

            $con->beginTransaction();

            try
            {

                $this->crud->changeTable('lms_ebooks');
                $args = array('isbn'=>$this->values['isbn'], 'name'=>$this->values['book_name'], 'description' => $this->values['description'], 'publisher' => $this->values['publisher'], 'author' => $this->values['author']);
                
                $data = $this->crud->update( $args, array('ebook_id' => $this->values['id']) );
                
                $con->commit();

                $this->crud->changeTable('lms_books');

                $this->flag = SUCCESS;
                $this->message = __(' Book updated');
                return true;
            }
            catch(Exception $e)
            {
                $con->rollBack();
                $this->flag = ERROR;
                $this->message = __("Error updating book. Error : "). $e->getMessage();
                return true;
            }
        }
        elseif($single = 'all')
        {

            if(!$this->check_form($this->values, ['book_name'=>'Book name', 'description' => 'Description', 'language' => 'Language', 'category' => 'Category', 'publisher' => 'Publisher', 'year' => 'Year', 'author' => 'Author'], '{description},{language}')) {
                $this->flag = ERROR;
                return false;
            }

            
            if($this->processaddfile() == false) {
                return false;
            }
            $this->values['photo'] = $this->values['download_file'];
            if($this->processaddebookfile() == false) {
                return false;
            }

            
            $con = $this->crud->get_connection();

            $con->beginTransaction();

            try
            {   

                $this->crud->changeTable('lms_ebooks');

                $args = array('name'=>$this->values['book_name'], 'description' => $this->values['description'], 'language' => $this->values['language'], 'category' => $this->values['category'], 'publisher' => $this->values['publisher'], 'published_year' => $this->values['year'], 'author' => $this->values['author'], 'photo' => $this->values['photo'], 'download_file' => $this->values['download_file']);
                
                if($this->values['download_file'] == '')
                    unset($args['download_file']);
                
                if($this->values['photo'] == '')
                    unset($args['photo']);


                if($this->values['photo'] != '')
                {
                    $cover = $this->crud->get_by( array( 'ebook_id' => $this->values['id'] ), '=', true);
                    $cover = $cover->photo;
                    if($cover != '')
                        unlink($cover);
                }
                if($this->values['download_file'] != '')
                {
                    $cover = $this->crud->get_by( array( 'ebook_id' => $this->values['id'] ), '=', true);
                    $cover = $cover->download_file;
                    if($cover != '')
                        unlink($cover);
                }


                $data = $this->crud->update( $args, array('ebook_id' => $this->values['id']) );
                
                $con->commit();

                $this->crud->changeTable('lms_books');

                $this->flag = SUCCESS;
                $this->message = __(' Book updated');
                return true;
            }
            catch(Exception $e)
            {
                $con->rollBack();
                $this->flag = ERROR;
                $this->message = __("Error updating book. Error : "). $e->getMessage();
                return true;
            }
        }
        
    }

    function process_ebook_export()
    {
          header('Content-Type: text/csv; charset=utf-8');  
          header('Content-Disposition: attachment; filename=ebook.csv');  
          $output = fopen("php://output", "w+");  
          fputcsv($output, array('name', 'isbn', 'description', 'language', 'publisher', 'published_year', 'category', 'file', 'author'));  
          $query = "SELECT name,isbn,description,language,publisher,published_year,category,download_file,author from lms_ebooks";
          $smt = $this->crud->get_connection()->prepare($query);
          $smt->execute();

          while($row = $smt->fetch(PDO::FETCH_ASSOC))  
          {  
               fputcsv($output, $row);  
          }  
          fclose($output);  
    }
    function check_ebook($book_id)
    {
        $query = 'select * from lms_ebooks where ebook_id = :book_id';
        $book = $this->crud->exec_query($query, array(':book_id' => $book_id))->fetchAll(PDO::FETCH_CLASS);
        
        if(count($book) <= 0)
        {
            $this->flag = ERROR;
            $this->message = __("Invalid access");
            return false;
        }
        return $book[0];
    }

    function get_ebook_by_id($book_id)
    {
        $query = 'select * from lms_ebooks where ebook_id = :book_id';
        $book = $this->crud->exec_query($query, array(':book_id' => $book_id))->fetchAll(PDO::FETCH_CLASS);
        
        if(count($book) <= 0)
        {
            $this->flag = ERROR;
            $this->message = __("Invalid access");
            return false;
        }
        return $book[0];
    }


}