<?php
/**
 * File contains necessary information that defines the bootstrap of your application
 * Source code pattern must not be modified
 * Files to be used with the comments.
 * @Author : Operce Technologies
 * @Developer : Manhar Sharma
 * @Year : 2016
 *
 *
 **/


/**
 * class for login
 * pattern must not be modified
 * Files to be used with the comments.
 *
 *
 */

defined('_DONUT') or die('Error. Invalid Access');

class users extends Model {
    public $page_title;
    public $message;
    public $flag;
    public $values;
    private $crud;

    function __construct() {
        $this->crud = new crud('lms_users');
    }

    function process_student() {
        $this->values = $_POST;
        if(!$this->check_form($this->values, ['student_name'=>'Student name', 'email'=>'Email', 'username' => 'Username', 'password' => 'Password', 'phone'=>'Phone number', 'address' => 'Address', 'registration_number' => 'Registration number', 'father_name' => 'Father\'s name', 'class' => 'Class'], '{phone}')) {
            $this->flag = ERROR;
            return false;
        }
        
        if($this->check_data($this->values['email'], 'email') == false)
        {
            $this->message = __('Please enter valid email');
            $this->flag = ERROR;
            return false;
        }
        if($this->values['phone'] != '' && $this->check_data($this->values['phone'], 'int') == false)
        {
            $this->message = __('Please enter valid phone number');
            $this->flag = ERROR;
            return false;
        }

        $this->values['password'] = sha1(AUTH_KEY.$this->values['password']);
        $this->add_student();
    }

    private function add_student() {
        $con = $this->crud->get_connection();

        $con->beginTransaction();

        try
        {

            $dt = new DateTime();
            $date = $dt->format('Y-m-d H:i:s');
            $data = $this->crud->insert( array('name'=>$this->values['student_name'], 'email'=>$this->values['email'], 'username' => $this->values['username'], 'password' => $this->values['password'], 'phone'=>$this->values['phone'], 'address' => $this->values['address'], 'type' => 'S', 'date' => $date) );
            
            
            $this->crud->changeTable('lms_students');
            $data = $this->crud->insert( array('user_id'=>$data, 'registration_no'=>$this->values['registration_number'], 'fathers_name'=>$this->values['father_name'], 'class' => $this->values['class'], 'roll_no' => $this->values['roll'], 'date' => $date) );
            
            $this->crud->changeTable('lms_users');

            $con->commit();

            $this->values = [];
            $this->flag = SUCCESS;
            $this->message = __(' Student Added');
            return true;
        }
        catch(Exception $e)
        {
            $con->rollBack();
            $this->flag = ERROR;
            $this->message = __("Error adding student. Error : "). $e->getMessage();
            return true;
        }
        
    }

    function process_teacher() {
        $this->values = $_POST;
        if(!$this->check_form($this->values, ['member_id'=>'Member unique id', 'faculty_name'=>'Faculty name', 'email'=>'Email', 'username' => 'Username', 'password' => 'Password', 'phone'=>'Phone number', 'address' => 'Address', 'designation' => 'Designation'], '{phone}')) {
            $this->flag = ERROR;
            return false;
        }

        if(!$this->check_data($this->values['email'], 'email'))
        {
            $this->message = __('Please enter valid email');
            $this->flag = ERROR;
            return false;
        }
        if($this->values['phone'] != '' && $this->check_data($this->values['phone'], 'int') == false)
        {
            $this->message = __('Please enter valid phone number');
            $this->flag = ERROR;
            return false;
        }
        $this->values['password'] = sha1(AUTH_KEY.$this->values['password']);
        $this->add_teacher();
    }

    private function add_teacher() {
        $con = $this->crud->get_connection();

        $con->beginTransaction();

        try
        {
            $dt = new DateTime();
            $date = $dt->format('Y-m-d H:i:s');
            $data = $this->crud->insert( array('name'=>$this->values['faculty_name'], 'email'=>$this->values['email'], 'username' => $this->values['username'], 'password' => $this->values['password'], 'phone'=>$this->values['phone'], 'address' => $this->values['address'], 'type' => 'T', 'date' => $date) );
            
            
            $this->crud->changeTable('lms_staff');
            $data = $this->crud->insert( array('user_id'=>$data, 'member_id'=>$this->values['member_id'], 'designation'=>$this->values['designation'], 'date' => $date) );
            
            $this->crud->changeTable('lms_users');

            $con->commit();

            $this->flag = SUCCESS;
            $this->message = __('Staff Member Added');
            return true;
        }
        catch(Exception $e)
        {
            $con->rollBack();
            $this->flag = ERROR;
            $this->message = __("Error adding staff member. Error : "). $e->getMessage();
            return true;
        }
        
    }

    function delete_student($id)
    {
        $con = $this->crud->get_connection();

        $con->beginTransaction();

        try
        {
            $data = $this->crud->delete( array('user_id' => $id) );
            
            $this->crud->changeTable('lms_students');
            $data = $this->crud->delete( array('user_id'=>$id) );
            
            $this->crud->changeTable('lms_issue');
            $data = $this->crud->delete( array('user_id'=>$id) );

            $con->commit();

            $this->flag = SUCCESS;
            $this->message = __('Data Deleted');
            return true;
        }
        catch(Exception $e)
        {
            $con->rollBack();
            $this->flag = ERROR;
            $this->message = __("Error deleting student. Error : "). $e->getMessage();
            return true;
        }
    }

    function delete_teacher($id)
    {
        $con = $this->crud->get_connection();

        $con->beginTransaction();

        try
        {
            $data = $this->crud->delete( array('user_id' => $id) );
            
            $this->crud->changeTable('lms_staff');
            $data = $this->crud->delete( array('user_id'=>$id) );
            
            $this->crud->changeTable('lms_issue');
            $data = $this->crud->delete( array('user_id'=>$id) );

            $con->commit();

            $this->flag = SUCCESS;
            $this->message = __('Data Deleted');
            return true;
        }
        catch(Exception $e)
        {
            $con->rollBack();
            $this->flag = ERROR;
            $this->message = __("Error deleting details. Error : "). $e->getMessage();
            return true;
        }
    }

    function get_classes() {
        $this->crud->changeTable('lms_class');
        $data = $this->crud->get_all();
        $this->crud->changeTable('lms_users');
        return $data;
    }

    function get_designations() {
        $this->crud->changeTable('lms_designation');
        $data = $this->crud->get_all();
        $this->crud->changeTable('lms_users');
        return $data;
    }

    function get_users()
    {
         $query = "select * from lms_users where type = 'S' or type = 'T'";
         $data = $this->crud->exec_query($query)->fetchAll(PDO::FETCH_CLASS);
         return $data;
    }




    function get_users_count($args = 'today', $type = 'S') {

        $query = "SELECT * FROM lms_users WHERE type = '$type'";
        $flag = false;
        
        $data = $this->crud->exec_query($query)->fetchAll(PDO::FETCH_CLASS);
        return $data;
    }



    function get_teachers($filter = array(),$limit = false) {
        $query = "select * from lms_users inner join lms_staff on lms_users.user_id = lms_staff.user_id where lms_users.type = 'T'";
        $flag = true;

        if(isset($filter['name']))
        {
            if(!$this->check_form($filter, ['name'=>'Name'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND lms_users.name like '%".$filter['name']."%'" : $query . " where lms_users.name like '%".$filter['name']."%'" ;
            if($flag == false) $flag = true;
        }
        if(isset($filter['member_id']))
        {
            if(!$this->check_form($filter, ['member_id'=>'Member ID'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND lms_staff.member_id = '".$filter['member_id']."'" : $query . " where lms_staff.member_id = '".$filter['member_id']."'";
            if($flag == false) $flag = true;
        }
        if(isset($filter['email']))
        {
            if(!$this->check_form($filter, ['email'=>'Email'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND lms_users.email = '".$filter['email']."'" : $query . " where lms_users.email = '".$filter['email']."'";
            if($flag == false) $flag = true;
        }
        if(isset($filter['designation']))
        {
            if(!$this->check_form($filter, ['designation'=>'Designation'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND lms_staff.designation = '".$filter['designation']."'" : $query . " where lms_staff.designation = '".$filter['designation']."'";
            if($flag == false) $flag = true;
        }
        
        if($limit != false)
        {
            $query = $query.' '.$limit;
        }
        
        $data = $this->crud->exec_query($query)->fetchAll(PDO::FETCH_CLASS);
        return $data;
    }

    function get_students($filter = array(), $limit = false) {
        $query = "select * from lms_users inner join lms_students on lms_users.user_id = lms_students.user_id where lms_users.type = 'S'";
        $flag = true;

        if(isset($filter['name']))
        {
            if(!$this->check_form($filter, ['name'=>'Name'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND lms_users.name like '%".$filter['name']."%'" : $query . " where lms_users.name like '%".$filter['name']."%'" ;
            if($flag == false) $flag = true;
        }
        if(isset($filter['reg_no']))
        {
            if(!$this->check_form($filter, ['reg_no'=>'Registration no'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND lms_students.registration_no = '".$filter['reg_no']."'" : $query . " where lms_students.registration_no = '".$filter['reg_no']."'";
            if($flag == false) $flag = true;
        }
        if(isset($filter['class']))
        {
            if(!$this->check_form($filter, ['class'=>'Class'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND lms_students.class = '".$filter['class']."'" : $query . " where lms_students.class = '".$filter['class']."'";
            if($flag == false) $flag = true;
        }
        if(isset($filter['roll_no']))
        {
            if(!$this->check_form($filter, ['roll_no'=>'Roll no'])) {
                $this->flag = ERROR;
                return false;
            }
            $query = ($flag == true) ? $query . " AND lms_students.roll_no = '".$filter['roll_no']."'" : $query . " where lms_students.roll_no = '".$filter['roll_no']."'";
            if($flag == false) $flag = true;
        }
        
        if($limit != false)
        {
            $query = $query.' '.$limit;
        }
        
        $data = $this->crud->exec_query($query)->fetchAll(PDO::FETCH_CLASS);
        return $data;
    }


    function update_student($single = false)
    {
        if($single == false)
        {
            $this->values = $_POST;
            if(!$this->check_form($this->values, ['name'=>'Student name', 'email'=>'Email', 'phone'=>'Phone number', 'address' => 'Address', 'reg_no' => 'Registration number', 'father_name' => 'Father\'s name', 'class' => 'Class'], '{phone}')) {
                $this->flag = ERROR;
                return false;
            }

            if($this->check_data($this->values['email'], 'email') == false)
            {
                $this->message = __('Please enter valid email');
                $this->flag = ERROR;
                return false;
            }

            $con = $this->crud->get_connection();

            $con->beginTransaction();

            try
            {
                $data = $this->crud->update( array('name'=>$this->values['name'], 'email'=>$this->values['email'], 'phone'=>$this->values['phone'], 'address' => $this->values['address']), array('type' => 'S', 'user_id' => $this->values['id']) );
                
                
                $this->crud->changeTable('lms_students');
                $data = $this->crud->update( array('registration_no'=>$this->values['reg_no'], 'fathers_name'=>$this->values['father_name'], 'class' => $this->values['class'], 'roll_no' => $this->values['roll_no']), array('user_id' => $this->values['id']) );
                

                $con->commit();

                $this->flag = SUCCESS;
                $this->message = __(' Student updated');
                return true;
            }
            catch(Exception $e)
            {
                $con->rollBack();
                $this->flag = ERROR;
                $this->message = __("Error updating student. Error : "). $e->getMessage();
                return true;
            }
        }
        elseif($single = 'all')
        {
            $this->values = $_POST;
            if(!$this->check_form($this->values, ['student_name'=>'Student name', 'email'=>'Email', 'username' => 'Username', 'phone'=>'Phone number', 'address' => 'Address', 'registration_number' => 'Registration number', 'father_name' => 'Father\'s name', 'class' => 'Class'], '{phone}')) {
                $this->flag = ERROR;
                return false;
            }            
        
            if($this->check_data($this->values['email'], 'email') == false)
            {
                $this->message = __('Please enter valid email');
                $this->flag = ERROR;
                return false;
            }
            if($this->values['phone'] != '' && $this->check_data($this->values['phone'], 'int') == false)
            {
                $this->message = __('Please enter valid phone number');
                $this->flag = ERROR;
                return false;
            }         
            
            $con = $this->crud->get_connection();

            $con->beginTransaction();

            try
            {

                $data = $this->crud->update( array('name'=>$this->values['student_name'], 'email'=>$this->values['email'], 'username' => $this->values['username'], 'phone'=>$this->values['phone'], 'address' => $this->values['address']), array('type' => 'S', 'user_id' => $this->values['id']) );
                
                
                $this->crud->changeTable('lms_students');
                $data = $this->crud->update( array('registration_no'=>$this->values['registration_number'], 'fathers_name'=>$this->values['father_name'], 'class' => $this->values['class'], 'roll_no' => $this->values['roll']), array('user_id' => $this->values['id']) );
                

                $con->commit();

                $this->flag = SUCCESS;
                $this->message = __(' Student updated');
                return true;
            }
            catch(Exception $e)
            {
                $con->rollBack();
                $this->flag = ERROR;
                $this->message = __("Error updating student. Error : "). $e->getMessage();
                return true;
            }
        }

        
    }

    function update_teacher($single = false)
    {
        if($single == false)
        {
            $this->values = $_POST;
            if(!$this->check_form($this->values, ['name'=>'Member name', 'email'=>'Email', 'phone'=>'Phone number', 'address' => 'Address', 'member_id' => 'Member ID', 'designation' => 'Designation'], '{phone}')) {
                $this->flag = ERROR;
                return false;
            }

            if($this->check_data($this->values['email'], 'email') == false)
            {
                $this->message = __('Please enter valid email');
                $this->flag = ERROR;
                return false;
            }
            
            $con = $this->crud->get_connection();

            $con->beginTransaction();

            try
            {
                $data = $this->crud->update( array('name'=>$this->values['name'], 'email'=>$this->values['email'], 'phone'=>$this->values['phone'], 'address' => $this->values['address']), array('type' => 'T', 'user_id' => $this->values['id']) );
                
                
                $this->crud->changeTable('lms_staff');
                $data = $this->crud->update( array('member_id'=>$this->values['member_id'], 'designation'=>$this->values['designation']), array('user_id' => $this->values['id']) );
                

                $con->commit();

                $this->flag = SUCCESS;
                $this->message = __(' Teacher details updated');
                return true;
            }
            catch(Exception $e)
            {
                $con->rollBack();
                $this->flag = ERROR;
                $this->message = __("Error updating teacher details. Error : "). $e->getMessage();
                return true;
            }
        }

        elseif($single = 'all')
        {
            $this->values = $_POST;
            if(!$this->check_form($this->values, ['member_id'=>'Member unique id', 'faculty_name'=>'Faculty name', 'email'=>'Email', 'username' => 'Username', 'phone'=>'Phone number', 'address' => 'Address', 'designation' => 'Designation'], '{phone}')) {
                $this->flag = ERROR;
                return false;
            }

            if(!$this->check_data($this->values['email'], 'email'))
            {
                $this->message = __('Please enter valid email');
                $this->flag = ERROR;
                return false;
            }
            if($this->values['phone'] != '' && $this->check_data($this->values['phone'], 'int') == false)
            {
                $this->message = __('Please enter valid phone number');
                $this->flag = ERROR;
                return false;
            }    
            
            $con = $this->crud->get_connection();

            $con->beginTransaction();

            try
            {
                $data = $this->crud->update( array('name'=>$this->values['faculty_name'], 'email'=>$this->values['email'], 'username' => $this->values['username'], 'phone'=>$this->values['phone'], 'address' => $this->values['address']), array('user_id' => $this->values['id']) );
                
                
                $this->crud->changeTable('lms_staff');
                $data = $this->crud->update( array('member_id'=>$this->values['member_id'], 'designation'=>$this->values['designation']), array('user_id' => $this->values['id']) );
                

                $con->commit();

                $this->flag = SUCCESS;
                $this->message = __('Details updated');
                return true;
            }
            catch(Exception $e)
            {
                $con->rollBack();
                $this->flag = ERROR;
                $this->message = __("Error updating details. Error : "). $e->getMessage();
                return true;
            }
        }

        
    }

    function check_student($book_id)
    {
        $query = 'select * from lms_users inner join lms_students on lms_users.user_id = lms_students.user_id where lms_users.user_id = :book_id';
        $book = $this->crud->exec_query($query, array(':book_id' => $book_id))->fetchAll(PDO::FETCH_CLASS);
        
        if(count($book) <= 0)
        {
            $this->flag = ERROR;
            $this->message = __("Invalid access");
            return false;
        }
        return $book[0];
    }

    function check_teacher($book_id)
    {
        $query = 'select * from lms_users inner join lms_staff on lms_users.user_id = lms_staff.user_id where lms_users.user_id = :book_id';
        $book = $this->crud->exec_query($query, array(':book_id' => $book_id))->fetchAll(PDO::FETCH_CLASS);
        
        if(count($book) <= 0)
        {
            $this->flag = ERROR;
            $this->message = __("Invalid access");
            return false;
        }
        return $book[0];
    }

    function regenerate_password($user_id)
    {
        $pass = $this->pass_generator();
        $pass_hash = sha1(AUTH_KEY.$pass);

        $data = $this->crud->update( array('password'=>$pass_hash), array('user_id' => $user_id) );
                
        if($data > 0)
        {
            $this->flag = SUCCESS;
            $this->message = __("Password has been updated. Password is ").$pass;
            return true;
        }
        return false;
    }

    function process_export_teachers()
    {
          header('Content-Type: text/csv; charset=utf-8');  
          header('Content-Disposition: attachment; filename=teachers.csv');  
          $output = fopen("php://output", "w+");  
          fputcsv($output, array('member_id', 'name', 'username', 'password', 'email', 'phone', 'address', 'designation'));  
          $query = "SELECT member_id, name, username, '****' as password, email, phone, address, designation from lms_users
          INNER JOIN lms_staff ON lms_staff.user_id = lms_users.user_id";
          $smt = $this->crud->get_connection()->prepare($query);
          $smt->execute();

          while($row = $smt->fetch(PDO::FETCH_ASSOC))  
          {  
               fputcsv($output, $row);  
          }  
          fclose($output);  
    }

    function process_export_students()
    {
          header('Content-Type: text/csv; charset=utf-8');  
          header('Content-Disposition: attachment; filename=students.csv');  
          $output = fopen("php://output", "w+");  
          fputcsv($output, array('registration number', 'father\'s name', 'class', 'roll no', 'name', 'username', 'password', 'email', 'phone', 'address'));  
          $query = "SELECT registration_no, fathers_name, class, roll_no, name, username, '****' as password, email, phone, address from lms_users
          INNER JOIN lms_students ON lms_students.user_id = lms_users.user_id";
          $smt = $this->crud->get_connection()->prepare($query);
          $smt->execute();

          while($row = $smt->fetch(PDO::FETCH_ASSOC))  
          {  
               fputcsv($output, $row);  
          }  
          fclose($output);  
    }

    function process_import_teachers()
    {
        if(isset($_FILES['csv_file']))
        {
            $imageFileType = pathinfo(basename($_FILES["csv_file"]["name"]),PATHINFO_EXTENSION);

            if($imageFileType != "CSV" && $imageFileType != "csv") {
                $this->flag = ERROR;
                $this->message = __("Valid CSV is required");
                return false;
            }
                $flag = true;
                $filename =  $_FILES['csv_file']['tmp_name'];
                $file = fopen($filename, "r");
                $count = 0;
                while (($getData = fgetcsv($file)) !== FALSE)
                 {
                    if($count <= 0)
                    {
                        $count++;
                        continue;
                    }
                    if(count($getData) < 8)
                    {

                        $this->flag = ERROR;
                        $flag = false;
                        if(isset($this->message))
                             $this->message .= __("Invalid CSV data at line : ").($count+1).'<br>';
                        else
                            $this->message = __("Invalid CSV data at line : ").($count+1).'<br>';

                        $count++;
                        continue;
                    }
                    //'member_id', 'name', 'username', 'email', 'phone', 'address', 'designation'
                    $member_id = $getData[0];
                    $name = $getData[1];
                    $username = $getData[2];
                    $password = $getData[3];
                    $email = $getData[4];
                    $phone = $getData[5];
                    $address = $getData[6];
                    $designation = $getData[7];
                    $password = sha1(AUTH_KEY.$password);

                    if($this->check_data($email, 'email') == false || $this->check_data($phone, 'int') == false)
                    {
                        $this->flag = ERROR;
                        $flag = false;
                        if(isset($this->message))
                             $this->message .= __("Invalid CSV data at line : ").($count+1).'<br>';
                        else
                            $this->message = __("Invalid CSV data at line : ").($count+1).'<br>';


                        $count++;
                        continue;
                    }


                    $data_prev = $this->get_teachers( array('member_id' => $member_id));
                    if(!empty($data_prev) > 0)
                    {
                        $count++;

                        if(isset($this->message))
                             $this->message .= __("Teacher exists for id").$member_id.__(" at line : ").($count+1).'<br>';
                        else
                            $this->message = __("Teacher exists for id").$member_id.__(" at line : ").($count+1).'<br>';
                        continue;
                    }
                    $this->values = [
                        'faculty_name' => $name,
                        'designation' => $designation,
                        'username' => $username,
                        'email' => $email,
                        'password' => $password,
                        'address' => $address,
                        'member_id' => $member_id,
                        'phone' => $phone
                    ];

                    $this->add_teacher();
                    
                    if(!empty($data))
                    {
                        $this->flag = SUCCESS;
                    }
                    else
                    {
                        $this->flag = ERROR;
                        $flag = false;
                        if(isset($this->message))
                             $this->message .= __("Error Inserting teachers"). ($count+1).'<br>';
                        else
                            $this->message = __("Error Inserting teachers"). ($count+1).'<br>';
                    }

                    $count++;
                }
                
                fclose($file); 
                if($this->flag == SUCCESS)
                { 
                    $this->message = __("Teachers imported successfully");
                    return true;
                }
                else return false;
        }

        return true;

    }

    function process_import_students()
    {
        if(isset($_FILES['csv_file']))
        {
            $imageFileType = pathinfo(basename($_FILES["csv_file"]["name"]),PATHINFO_EXTENSION);

            if($imageFileType != "CSV" && $imageFileType != "csv") {
                $this->flag = ERROR;
                $this->message = __("Valid CSV is required");
                return false;
            }
                $flag = true;
                $filename =  $_FILES['csv_file']['tmp_name'];
                $file = fopen($filename, "r");
                $count = 0;
                while (($getData = fgetcsv($file)) !== FALSE)
                 {
                    if($count <= 0)
                    {
                        $count++;
                        continue;
                    }
                    if(count($getData) < 10)
                    {

                        $this->flag = ERROR;
                        $flag = false;
                        if(isset($this->message))
                             $this->message .= __("Invalid CSV data at line : ").($count+1).'<br>';
                        else
                            $this->message = __("Invalid CSV data at line : ").($count+1).'<br>';

                        $count++;
                        continue;
                    }
                    //''registration number', 'father\'s name', 'class', 'roll no', 'name', 'username', 'password', 'email', 'phone', 'address'
                    $registration = $getData[0];
                    $fathers_name = $getData[1];
                    $class = $getData[2];
                    $roll_no = $getData[3];
                    $name = $getData[4];
                    $username = $getData[5];
                    $password = $getData[6];
                    $email = $getData[7];
                    $phone = $getData[8];
                    $address = $getData[9];
                    $password = sha1(AUTH_KEY.$password);

                    if($this->check_data($email, 'email') == false || $this->check_data($phone, 'int') == false)
                    {
                        $this->flag = ERROR;
                        $flag = false;
                        if(isset($this->message))
                             $this->message .= __("Invalid CSV data at line : ").($count+1).'<br>';
                        else
                            $this->message = __("Invalid CSV data at line : ").($count+1).'<br>';


                        $count++;
                        continue;
                    }


                    $data_prev = $this->get_students( array('roll_no' => $roll_no));
                    if(!empty($data_prev) > 0)
                    {
                        $count++;

                        if(isset($this->message))
                             $this->message .= __("Student exists for id").$member_id.__(" at line : ").($count+1).'<br>';
                        else
                            $this->message = __("Student exists for id").$member_id.__(" at line : ").($count+1).'<br>';
                        continue;
                    }

                    $this->crud->changeTable('lms_class');
                    $classes = $this->crud->get_by( array('class' => $class), '=', true);
                    if(!empty($classes))
                    {
                        $class = $classes->class;
                    }
                    else
                    {
                        $this->crud->insert( array('class' => $class, 'date' => date('Y-m-d')) );
                    }
                    $this->crud->changeTable('lms_users');
                    $this->values = [
                        'student_name' => $name,
                        'class' => $class,
                        'roll' => $roll_no,
                        'father_name' => $fathers_name,
                        'registration_number' => $registration,
                        'username' => $username,
                        'email' => $email,
                        'password' => $password,
                        'address' => $address,
                        'phone' => $phone
                    ];

                    $this->add_student();
                    
                    if(!empty($data))
                    {
                        $this->flag = SUCCESS;
                    }
                    else
                    {
                        $this->flag = ERROR;
                        $flag = false;
                        if(isset($this->message))
                             $this->message .= __("Error Inserting Students"). ($count+1).'<br>';
                        else
                            $this->message = __("Error Inserting Students"). ($count+1).'<br>';
                    }

                    $count++;
                }
                
                fclose($file); 
                if($this->flag == SUCCESS)
                { 
                    $this->message = __("Student imported successfully");
                    return true;
                }
                else return false;
        }

        return true;

    }

}